/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "chuck.y"


/*----------------------------------------------------------------------------
  ChucK Strongly-timed Audio Programming Language
    Compiler and Virtual Machine

  Copyright (c) 2003 Ge Wang and Perry R. Cook. All rights reserved.
    http://chuck.cs.princeton.edu/
    http://soundlab.cs.princeton.edu/

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  U.S.A.
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// file: chuck.tab.c
// desc: chuck parser
//
// author: Ge Wang (gewang@cs.princeton.edu) - generated by yacc
//         Perry R. Cook (prc@cs.princeton.edu)
//
// initial version created by Ge Wang;
// based on ansi C grammar by Jeff Lee, maintained by Jutta Degener
//
// date: Summer 2002
//-----------------------------------------------------------------------------
#include "chuck_absyn.h"
#include "chuck_errmsg.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// function
int yylex( void );

void yyerror( char * s )
{
    EM_error( EM_tokPos, "%s", s );
}

a_Program g_program = NULL;


#line 128 "chuck.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "chuck.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ID = 3,                         /* ID  */
  YYSYMBOL_STRING_LIT = 4,                 /* STRING_LIT  */
  YYSYMBOL_CHAR_LIT = 5,                   /* CHAR_LIT  */
  YYSYMBOL_INT_VAL = 6,                    /* INT_VAL  */
  YYSYMBOL_FLOAT_VAL = 7,                  /* FLOAT_VAL  */
  YYSYMBOL_POUND = 8,                      /* POUND  */
  YYSYMBOL_COMMA = 9,                      /* COMMA  */
  YYSYMBOL_COLON = 10,                     /* COLON  */
  YYSYMBOL_SEMICOLON = 11,                 /* SEMICOLON  */
  YYSYMBOL_LPAREN = 12,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 13,                    /* RPAREN  */
  YYSYMBOL_LBRACK = 14,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 15,                    /* RBRACK  */
  YYSYMBOL_LBRACE = 16,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 17,                    /* RBRACE  */
  YYSYMBOL_DOT = 18,                       /* DOT  */
  YYSYMBOL_PLUS = 19,                      /* PLUS  */
  YYSYMBOL_MINUS = 20,                     /* MINUS  */
  YYSYMBOL_TIMES = 21,                     /* TIMES  */
  YYSYMBOL_DIVIDE = 22,                    /* DIVIDE  */
  YYSYMBOL_PERCENT = 23,                   /* PERCENT  */
  YYSYMBOL_EQ = 24,                        /* EQ  */
  YYSYMBOL_NEQ = 25,                       /* NEQ  */
  YYSYMBOL_LT = 26,                        /* LT  */
  YYSYMBOL_LE = 27,                        /* LE  */
  YYSYMBOL_GT = 28,                        /* GT  */
  YYSYMBOL_GE = 29,                        /* GE  */
  YYSYMBOL_AND = 30,                       /* AND  */
  YYSYMBOL_OR = 31,                        /* OR  */
  YYSYMBOL_ASSIGN = 32,                    /* ASSIGN  */
  YYSYMBOL_IF = 33,                        /* IF  */
  YYSYMBOL_THEN = 34,                      /* THEN  */
  YYSYMBOL_ELSE = 35,                      /* ELSE  */
  YYSYMBOL_WHILE = 36,                     /* WHILE  */
  YYSYMBOL_FOR = 37,                       /* FOR  */
  YYSYMBOL_DO = 38,                        /* DO  */
  YYSYMBOL_LOOP = 39,                      /* LOOP  */
  YYSYMBOL_BREAK = 40,                     /* BREAK  */
  YYSYMBOL_CONTINUE = 41,                  /* CONTINUE  */
  YYSYMBOL_NULL_TOK = 42,                  /* NULL_TOK  */
  YYSYMBOL_FUNCTION = 43,                  /* FUNCTION  */
  YYSYMBOL_RETURN = 44,                    /* RETURN  */
  YYSYMBOL_QUESTION = 45,                  /* QUESTION  */
  YYSYMBOL_EXCLAMATION = 46,               /* EXCLAMATION  */
  YYSYMBOL_S_OR = 47,                      /* S_OR  */
  YYSYMBOL_S_AND = 48,                     /* S_AND  */
  YYSYMBOL_S_XOR = 49,                     /* S_XOR  */
  YYSYMBOL_PLUSPLUS = 50,                  /* PLUSPLUS  */
  YYSYMBOL_MINUSMINUS = 51,                /* MINUSMINUS  */
  YYSYMBOL_DOLLAR = 52,                    /* DOLLAR  */
  YYSYMBOL_POUNDPAREN = 53,                /* POUNDPAREN  */
  YYSYMBOL_PERCENTPAREN = 54,              /* PERCENTPAREN  */
  YYSYMBOL_ATPAREN = 55,                   /* ATPAREN  */
  YYSYMBOL_SIMULT = 56,                    /* SIMULT  */
  YYSYMBOL_PATTERN = 57,                   /* PATTERN  */
  YYSYMBOL_CODE = 58,                      /* CODE  */
  YYSYMBOL_TRANSPORT = 59,                 /* TRANSPORT  */
  YYSYMBOL_HOST = 60,                      /* HOST  */
  YYSYMBOL_TIME = 61,                      /* TIME  */
  YYSYMBOL_WHENEVER = 62,                  /* WHENEVER  */
  YYSYMBOL_NEXT = 63,                      /* NEXT  */
  YYSYMBOL_UNTIL = 64,                     /* UNTIL  */
  YYSYMBOL_EXTERNAL = 65,                  /* EXTERNAL  */
  YYSYMBOL_GLOBAL = 66,                    /* GLOBAL  */
  YYSYMBOL_EVERY = 67,                     /* EVERY  */
  YYSYMBOL_BEFORE = 68,                    /* BEFORE  */
  YYSYMBOL_AFTER = 69,                     /* AFTER  */
  YYSYMBOL_AT = 70,                        /* AT  */
  YYSYMBOL_AT_SYM = 71,                    /* AT_SYM  */
  YYSYMBOL_ATAT_SYM = 72,                  /* ATAT_SYM  */
  YYSYMBOL_NEW = 73,                       /* NEW  */
  YYSYMBOL_SIZEOF = 74,                    /* SIZEOF  */
  YYSYMBOL_TYPEOF = 75,                    /* TYPEOF  */
  YYSYMBOL_SAME = 76,                      /* SAME  */
  YYSYMBOL_PLUS_CHUCK = 77,                /* PLUS_CHUCK  */
  YYSYMBOL_MINUS_CHUCK = 78,               /* MINUS_CHUCK  */
  YYSYMBOL_TIMES_CHUCK = 79,               /* TIMES_CHUCK  */
  YYSYMBOL_DIVIDE_CHUCK = 80,              /* DIVIDE_CHUCK  */
  YYSYMBOL_S_AND_CHUCK = 81,               /* S_AND_CHUCK  */
  YYSYMBOL_S_OR_CHUCK = 82,                /* S_OR_CHUCK  */
  YYSYMBOL_S_XOR_CHUCK = 83,               /* S_XOR_CHUCK  */
  YYSYMBOL_SHIFT_RIGHT_CHUCK = 84,         /* SHIFT_RIGHT_CHUCK  */
  YYSYMBOL_SHIFT_LEFT_CHUCK = 85,          /* SHIFT_LEFT_CHUCK  */
  YYSYMBOL_PERCENT_CHUCK = 86,             /* PERCENT_CHUCK  */
  YYSYMBOL_SHIFT_RIGHT = 87,               /* SHIFT_RIGHT  */
  YYSYMBOL_SHIFT_LEFT = 88,                /* SHIFT_LEFT  */
  YYSYMBOL_TILDA = 89,                     /* TILDA  */
  YYSYMBOL_CHUCK = 90,                     /* CHUCK  */
  YYSYMBOL_COLONCOLON = 91,                /* COLONCOLON  */
  YYSYMBOL_S_CHUCK = 92,                   /* S_CHUCK  */
  YYSYMBOL_AT_CHUCK = 93,                  /* AT_CHUCK  */
  YYSYMBOL_LEFT_S_CHUCK = 94,              /* LEFT_S_CHUCK  */
  YYSYMBOL_UNCHUCK = 95,                   /* UNCHUCK  */
  YYSYMBOL_UPCHUCK = 96,                   /* UPCHUCK  */
  YYSYMBOL_DOWNCHUCK = 97,                 /* DOWNCHUCK  */
  YYSYMBOL_CLASS = 98,                     /* CLASS  */
  YYSYMBOL_INTERFACE = 99,                 /* INTERFACE  */
  YYSYMBOL_EXTENDS = 100,                  /* EXTENDS  */
  YYSYMBOL_IMPLEMENTS = 101,               /* IMPLEMENTS  */
  YYSYMBOL_PUBLIC = 102,                   /* PUBLIC  */
  YYSYMBOL_PROTECTED = 103,                /* PROTECTED  */
  YYSYMBOL_PRIVATE = 104,                  /* PRIVATE  */
  YYSYMBOL_STATIC = 105,                   /* STATIC  */
  YYSYMBOL_ABSTRACT = 106,                 /* ABSTRACT  */
  YYSYMBOL_CONST = 107,                    /* CONST  */
  YYSYMBOL_SPORK = 108,                    /* SPORK  */
  YYSYMBOL_ARROW_RIGHT = 109,              /* ARROW_RIGHT  */
  YYSYMBOL_ARROW_LEFT = 110,               /* ARROW_LEFT  */
  YYSYMBOL_L_HACK = 111,                   /* L_HACK  */
  YYSYMBOL_R_HACK = 112,                   /* R_HACK  */
  YYSYMBOL_GRUCK_RIGHT = 113,              /* GRUCK_RIGHT  */
  YYSYMBOL_GRUCK_LEFT = 114,               /* GRUCK_LEFT  */
  YYSYMBOL_UNGRUCK_RIGHT = 115,            /* UNGRUCK_RIGHT  */
  YYSYMBOL_UNGRUCK_LEFT = 116,             /* UNGRUCK_LEFT  */
  YYSYMBOL_AT_OP = 117,                    /* AT_OP  */
  YYSYMBOL_AT_CTOR = 118,                  /* AT_CTOR  */
  YYSYMBOL_AT_DTOR = 119,                  /* AT_DTOR  */
  YYSYMBOL_AT_IMPORT = 120,                /* AT_IMPORT  */
  YYSYMBOL_YYACCEPT = 121,                 /* $accept  */
  YYSYMBOL_program = 122,                  /* program  */
  YYSYMBOL_program_section = 123,          /* program_section  */
  YYSYMBOL_class_definition = 124,         /* class_definition  */
  YYSYMBOL_class_ext = 125,                /* class_ext  */
  YYSYMBOL_class_body = 126,               /* class_body  */
  YYSYMBOL_class_body2 = 127,              /* class_body2  */
  YYSYMBOL_class_section = 128,            /* class_section  */
  YYSYMBOL_iface_ext = 129,                /* iface_ext  */
  YYSYMBOL_id_list = 130,                  /* id_list  */
  YYSYMBOL_id_dot = 131,                   /* id_dot  */
  YYSYMBOL_function_definition = 132,      /* function_definition  */
  YYSYMBOL_class_decl = 133,               /* class_decl  */
  YYSYMBOL_function_decl = 134,            /* function_decl  */
  YYSYMBOL_static_decl = 135,              /* static_decl  */
  YYSYMBOL_type_decl_a = 136,              /* type_decl_a  */
  YYSYMBOL_type_decl_b = 137,              /* type_decl_b  */
  YYSYMBOL_type_decl = 138,                /* type_decl  */
  YYSYMBOL_type_decl2 = 139,               /* type_decl2  */
  YYSYMBOL_arg_list = 140,                 /* arg_list  */
  YYSYMBOL_statement_list = 141,           /* statement_list  */
  YYSYMBOL_statement = 142,                /* statement  */
  YYSYMBOL_jump_statement = 143,           /* jump_statement  */
  YYSYMBOL_selection_statement = 144,      /* selection_statement  */
  YYSYMBOL_loop_statement = 145,           /* loop_statement  */
  YYSYMBOL_code_segment = 146,             /* code_segment  */
  YYSYMBOL_import_statement = 147,         /* import_statement  */
  YYSYMBOL_import_list = 148,              /* import_list  */
  YYSYMBOL_import_target = 149,            /* import_target  */
  YYSYMBOL_expression_statement = 150,     /* expression_statement  */
  YYSYMBOL_expression = 151,               /* expression  */
  YYSYMBOL_chuck_expression = 152,         /* chuck_expression  */
  YYSYMBOL_arrow_expression = 153,         /* arrow_expression  */
  YYSYMBOL_array_exp = 154,                /* array_exp  */
  YYSYMBOL_array_empty = 155,              /* array_empty  */
  YYSYMBOL_decl_expression = 156,          /* decl_expression  */
  YYSYMBOL_var_decl_list = 157,            /* var_decl_list  */
  YYSYMBOL_var_decl = 158,                 /* var_decl  */
  YYSYMBOL_complex_exp = 159,              /* complex_exp  */
  YYSYMBOL_polar_exp = 160,                /* polar_exp  */
  YYSYMBOL_vec_exp = 161,                  /* vec_exp  */
  YYSYMBOL_chuck_operator = 162,           /* chuck_operator  */
  YYSYMBOL_arrow_operator = 163,           /* arrow_operator  */
  YYSYMBOL_conditional_expression = 164,   /* conditional_expression  */
  YYSYMBOL_logical_or_expression = 165,    /* logical_or_expression  */
  YYSYMBOL_logical_and_expression = 166,   /* logical_and_expression  */
  YYSYMBOL_inclusive_or_expression = 167,  /* inclusive_or_expression  */
  YYSYMBOL_exclusive_or_expression = 168,  /* exclusive_or_expression  */
  YYSYMBOL_and_expression = 169,           /* and_expression  */
  YYSYMBOL_equality_expression = 170,      /* equality_expression  */
  YYSYMBOL_relational_expression = 171,    /* relational_expression  */
  YYSYMBOL_shift_expression = 172,         /* shift_expression  */
  YYSYMBOL_additive_expression = 173,      /* additive_expression  */
  YYSYMBOL_multiplicative_expression = 174, /* multiplicative_expression  */
  YYSYMBOL_tilda_expression = 175,         /* tilda_expression  */
  YYSYMBOL_cast_expression = 176,          /* cast_expression  */
  YYSYMBOL_unary_expression = 177,         /* unary_expression  */
  YYSYMBOL_unary_operator = 178,           /* unary_operator  */
  YYSYMBOL_overloadable_operator = 179,    /* overloadable_operator  */
  YYSYMBOL_dur_expression = 180,           /* dur_expression  */
  YYSYMBOL_postfix_expression = 181,       /* postfix_expression  */
  YYSYMBOL_primary_expression = 182        /* primary_expression  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  128
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2349

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  121
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  62
/* YYNRULES -- Number of rules.  */
#define YYNRULES  264
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  445

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   375


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   211,   211,   212,   216,   217,   218,   222,   224,   226,
     228,   233,   234,   235,   236,   240,   241,   245,   246,   251,
     252,   253,   257,   261,   262,   266,   267,   271,   273,   275,
     277,   279,   281,   283,   285,   287,   289,   291,   293,   295,
     297,   302,   303,   304,   308,   309,   310,   311,   315,   316,
     317,   321,   322,   326,   327,   336,   337,   342,   343,   347,
     348,   352,   353,   357,   358,   359,   360,   362,   363,   367,
     368,   369,   370,   374,   376,   381,   383,   385,   387,   389,
     391,   393,   395,   400,   401,   405,   406,   410,   411,   414,
     419,   420,   424,   425,   429,   430,   435,   436,   441,   442,
     443,   445,   450,   451,   455,   456,   457,   458,   459,   460,
     461,   465,   466,   470,   471,   472,   473,   474,   475,   476,
     480,   485,   490,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   513,   514,
     515,   516,   517,   518,   522,   523,   528,   529,   534,   535,
     540,   541,   546,   547,   552,   553,   558,   559,   561,   566,
     567,   569,   571,   573,   578,   579,   581,   586,   587,   589,
     594,   595,   597,   599,   604,   605,   610,   611,   616,   617,
     619,   621,   623,   625,   627,   629,   631,   633,   635,   637,
     644,   645,   646,   647,   648,   649,   650,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   706,   707,   712,   713,   715,   717,
     719,   721,   723,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ID", "STRING_LIT",
  "CHAR_LIT", "INT_VAL", "FLOAT_VAL", "POUND", "COMMA", "COLON",
  "SEMICOLON", "LPAREN", "RPAREN", "LBRACK", "RBRACK", "LBRACE", "RBRACE",
  "DOT", "PLUS", "MINUS", "TIMES", "DIVIDE", "PERCENT", "EQ", "NEQ", "LT",
  "LE", "GT", "GE", "AND", "OR", "ASSIGN", "IF", "THEN", "ELSE", "WHILE",
  "FOR", "DO", "LOOP", "BREAK", "CONTINUE", "NULL_TOK", "FUNCTION",
  "RETURN", "QUESTION", "EXCLAMATION", "S_OR", "S_AND", "S_XOR",
  "PLUSPLUS", "MINUSMINUS", "DOLLAR", "POUNDPAREN", "PERCENTPAREN",
  "ATPAREN", "SIMULT", "PATTERN", "CODE", "TRANSPORT", "HOST", "TIME",
  "WHENEVER", "NEXT", "UNTIL", "EXTERNAL", "GLOBAL", "EVERY", "BEFORE",
  "AFTER", "AT", "AT_SYM", "ATAT_SYM", "NEW", "SIZEOF", "TYPEOF", "SAME",
  "PLUS_CHUCK", "MINUS_CHUCK", "TIMES_CHUCK", "DIVIDE_CHUCK",
  "S_AND_CHUCK", "S_OR_CHUCK", "S_XOR_CHUCK", "SHIFT_RIGHT_CHUCK",
  "SHIFT_LEFT_CHUCK", "PERCENT_CHUCK", "SHIFT_RIGHT", "SHIFT_LEFT",
  "TILDA", "CHUCK", "COLONCOLON", "S_CHUCK", "AT_CHUCK", "LEFT_S_CHUCK",
  "UNCHUCK", "UPCHUCK", "DOWNCHUCK", "CLASS", "INTERFACE", "EXTENDS",
  "IMPLEMENTS", "PUBLIC", "PROTECTED", "PRIVATE", "STATIC", "ABSTRACT",
  "CONST", "SPORK", "ARROW_RIGHT", "ARROW_LEFT", "L_HACK", "R_HACK",
  "GRUCK_RIGHT", "GRUCK_LEFT", "UNGRUCK_RIGHT", "UNGRUCK_LEFT", "AT_OP",
  "AT_CTOR", "AT_DTOR", "AT_IMPORT", "$accept", "program",
  "program_section", "class_definition", "class_ext", "class_body",
  "class_body2", "class_section", "iface_ext", "id_list", "id_dot",
  "function_definition", "class_decl", "function_decl", "static_decl",
  "type_decl_a", "type_decl_b", "type_decl", "type_decl2", "arg_list",
  "statement_list", "statement", "jump_statement", "selection_statement",
  "loop_statement", "code_segment", "import_statement", "import_list",
  "import_target", "expression_statement", "expression",
  "chuck_expression", "arrow_expression", "array_exp", "array_empty",
  "decl_expression", "var_decl_list", "var_decl", "complex_exp",
  "polar_exp", "vec_exp", "chuck_operator", "arrow_operator",
  "conditional_expression", "logical_or_expression",
  "logical_and_expression", "inclusive_or_expression",
  "exclusive_or_expression", "and_expression", "equality_expression",
  "relational_expression", "shift_expression", "additive_expression",
  "multiplicative_expression", "tilda_expression", "cast_expression",
  "unary_expression", "unary_operator", "overloadable_operator",
  "dur_expression", "postfix_expression", "primary_expression", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-320)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-52)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     644,    14,  -320,  -320,  -320,  -320,  -320,  1191,  1869,   754,
    -320,  -320,  -320,    35,    72,   107,   132,   974,   145,    41,
      90,  -320,  1265,  -320,  1943,  1943,  1869,  1869,  1869,   161,
      44,    44,    44,  1943,  1943,   147,  -320,  -320,   130,  -320,
     148,    13,    93,  1869,    47,   314,  -320,  -320,  -320,   154,
      24,  -320,  -320,   147,   974,  -320,  -320,  -320,  -320,  -320,
    -320,  -320,    82,   141,    11,  -320,  -320,  -320,  -320,  -320,
    -320,     0,   149,   170,   222,   227,   224,   173,   167,   239,
     186,   187,   225,  -320,  1943,   188,    36,  -320,  -320,  -320,
      40,   113,  -320,   864,   260,   252,  1869,  1869,  1339,    -7,
    1869,  -320,  -320,  -320,   185,  -320,  -320,  -320,    53,   122,
     123,  1869,   210,   147,   147,   198,  -320,  -320,   221,  -320,
     273,   147,   147,  -320,     1,  -320,   279,  -320,  -320,  -320,
     281,   281,  -320,  -320,   274,   275,    64,  -320,  -320,  1869,
    -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,
    -320,  -320,  -320,  -320,  -320,  -320,  1869,  -320,  -320,  -320,
    -320,  -320,  -320,  1869,  1943,  1869,  1943,  1943,  1943,  1943,
    1943,  1943,  1943,  1943,  1943,  1943,  1943,  1943,  1943,  1943,
    1943,  1943,  1943,  1943,    44,  -320,   134,  1413,   282,  -320,
    -320,  -320,  -320,  1493,   277,  -320,    35,   217,   136,   138,
    1339,   230,   280,   283,   143,  -320,  -320,  -320,  -320,   150,
    -320,  -320,  1567,  -320,  1641,  1721,  -320,   284,   147,  -320,
    -320,  -320,   272,   285,   287,     4,     7,    43,    52,    12,
     286,     6,   141,    11,  -320,   149,   251,   170,   222,   227,
     224,   173,   173,   167,   167,   167,   167,   239,   239,   186,
     186,   187,   187,   187,   225,  -320,    36,  -320,   156,  -320,
     277,  -320,  -320,  -320,   974,   974,  1795,  1869,  1869,  1869,
     974,   974,   277,   157,   277,   162,  -320,   278,  -320,  -320,
     279,   281,   424,    35,   281,   288,   424,   281,   289,   290,
     147,   297,   290,   298,    85,   300,   284,   291,  2036,  1943,
    -320,  -320,   262,  -320,   974,   163,   171,   172,   182,  -320,
    -320,  -320,   277,  -320,   277,  -320,  -320,  -320,  -320,   295,
    -320,   534,  -320,   974,   200,   199,   424,   296,  -320,   424,
    -320,   293,   290,  -320,   290,   290,   303,    89,  1077,  -320,
    -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,
    -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,
    -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,
    -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,  -320,
    -320,  -320,  -320,  -320,  -320,  -320,   310,  -320,   974,  -320,
     974,   974,   312,   313,  -320,  -320,  -320,  -320,   281,    35,
     315,  -320,   319,    44,  -320,  -320,  -320,   290,    48,   316,
      35,   318,   324,    44,  -320,  -320,  -320,  -320,  -320,  -320,
    -320,  -320,  -320,  -320,  -320,  -320,  -320,    92,  2135,   326,
     328,  -320,  -320,  2233,   290,    44,   290,   329,  -320,   330,
    -320,   290,   290,  -320,  -320
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
      43,   253,   256,   257,   254,   255,    90,     0,     0,     0,
     190,   191,   194,     0,     0,     0,     0,     0,     0,     0,
       0,    44,     0,   193,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   196,    45,    46,
      47,     0,     0,     0,     0,    43,     2,     6,     5,     0,
      50,    55,    56,     0,     4,    61,    66,    65,    64,    67,
      68,    63,     0,    92,    94,   258,    96,   259,   260,   261,
     104,   144,   146,   148,   150,   152,   154,   156,   159,   164,
     167,   170,   174,   176,     0,   178,   244,   246,    52,   264,
       0,     0,    83,     0,    25,     0,     0,     0,     0,     0,
       0,    71,    72,    69,     0,   253,   179,   180,     0,     0,
       0,     0,    51,     0,     0,   184,   183,   182,   113,   109,
     111,     0,     0,   195,     0,    89,     0,    85,     1,     3,
       0,     0,    48,    49,     0,     0,     0,   105,    62,     0,
      91,   125,   126,   127,   128,   135,   136,   137,   129,   130,
     131,   123,   124,   132,   133,   134,     0,   139,   138,   141,
     140,   143,   142,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   181,     0,     0,     0,   251,
     252,   247,   263,     0,    98,    84,     0,    53,     0,     0,
       0,     0,     0,     0,     0,    70,   120,   121,   122,     0,
     106,   107,     0,   185,     0,     0,   114,   115,     0,   110,
     108,   262,     0,    87,    23,     0,     0,     0,     0,    51,
      57,     0,    93,    95,    97,   147,     0,   149,   151,   153,
     155,   157,   158,   160,   162,   161,   163,   166,   165,   168,
     169,   171,   172,   173,   175,   177,   245,   248,     0,   250,
      99,   100,    26,    54,     0,     0,     0,     0,     0,     0,
       0,     0,   186,     0,   116,     0,   102,     0,   112,    86,
       0,     0,    43,     0,     0,     0,    43,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    58,     0,     0,     0,
     249,   101,    73,    75,     0,     0,     0,     0,     0,    82,
      80,   188,   187,   118,   117,   103,    88,    24,    21,     0,
      15,    43,    20,    19,    13,    11,    43,     0,    22,    43,
      32,    59,     0,    33,     0,     0,     0,     0,     0,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   197,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   145,     0,    77,
       0,     0,     0,     0,   189,   119,     7,    18,     0,     0,
       0,     9,     0,     0,    31,    34,    30,     0,     0,     0,
     205,     0,     0,     0,    74,    78,    79,    76,    81,    14,
      12,     8,    10,    60,    29,    36,    28,     0,     0,     0,
       0,    35,    27,     0,     0,     0,     0,     0,    38,     0,
      37,     0,     0,    40,    39
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -320,  -320,   294,    30,  -320,  -258,    23,  -320,  -320,  -126,
    -183,    37,  -320,  -320,  -320,  -320,  -320,   -30,  -320,  -220,
      32,   -14,  -320,  -320,  -320,  -274,  -320,    65,   302,   -84,
      -1,  -117,   192,   -82,    97,   193,   -41,    59,  -320,  -320,
    -320,  -320,  -320,    60,  -320,   197,   196,   203,   195,   202,
      99,    31,    86,    95,    62,   183,    10,  -320,  -319,  -320,
     189,  -320
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    45,    46,   318,   285,   319,   320,   321,   288,   225,
      95,   322,    49,    50,   136,    51,    52,    53,   231,   291,
     323,    55,    56,    57,    58,    59,    60,   222,   223,    61,
      62,    63,    64,    65,   217,    66,   119,   120,    67,    68,
      69,   156,   163,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,   386,    85,
      86,    87
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     113,   114,   115,    99,   191,   226,    90,    91,   293,   297,
     139,   122,   137,   262,   200,   330,   112,   -51,   333,   412,
     282,   104,   232,   286,   294,   108,   109,   110,   327,   202,
      47,   164,    54,   213,   106,   107,   216,    48,    94,    13,
     138,    93,   124,   116,   117,   165,   112,   112,   187,   139,
       8,   125,   101,   192,   188,   112,   289,   203,   404,   425,
     405,   406,   139,   126,     9,   292,   206,   229,   400,    13,
      13,   402,   210,   211,   336,    47,   232,    54,    13,   138,
     219,   220,    48,    88,    96,    88,   189,   190,   112,   121,
      13,   139,   112,   140,   185,   198,   199,   201,   335,   204,
     324,   102,   408,   431,   283,   284,   230,   287,     9,   434,
     209,    13,   261,   221,   437,    13,   266,   409,   411,    97,
     157,   158,   193,   298,   159,   160,   161,   162,   194,   132,
     133,   139,   139,   424,   426,   207,   208,   105,     2,     3,
       4,     5,   134,   135,    98,   139,     7,   139,     8,   264,
     118,   265,   139,   432,   255,   317,   270,   100,   325,   139,
     438,   328,   440,   271,   236,   139,   139,   443,   444,   300,
     312,   139,   139,   111,   191,   314,   390,   278,   301,   166,
     139,   139,   123,   423,   391,   392,   258,    26,    27,    28,
     311,   139,   313,   430,   139,   393,   205,   290,   290,   172,
     173,   174,   175,   243,   244,   245,   246,   180,   181,   182,
     212,   273,     8,   275,    91,   439,   420,   167,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   -41,   -41,
     394,   151,   395,   214,   152,   215,   153,   154,   155,   139,
     267,   140,   251,   252,   253,    43,   -42,   -42,   170,   171,
     302,   303,   130,   131,   176,   177,   309,   310,   178,   179,
     139,   299,   247,   248,   290,   305,   306,   307,   308,   241,
     242,   168,   419,   249,   250,   169,   183,   184,   196,   186,
     197,    88,   218,   125,   224,   259,   227,   228,   263,   279,
     389,     8,   268,   315,   280,   269,   281,   388,   277,   399,
     295,   398,   403,   337,   326,   329,     9,   290,   290,   138,
     332,   334,   396,   401,   128,   276,   407,     1,     2,     3,
       4,     5,   413,   417,   418,     6,     7,   296,     8,   427,
       9,   428,   421,    10,    11,    12,   422,   429,   435,   129,
      13,   436,   441,   442,   397,   316,   127,    14,   233,   331,
      15,    16,    17,    18,    19,    20,   234,    21,    22,   387,
      23,   235,   237,   239,    24,    25,   254,    26,    27,    28,
     238,   240,     0,   290,   414,   256,   415,   416,    29,    30,
      31,     0,     0,   290,     0,     0,     0,    32,    33,    34,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,   290,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     0,    38,    39,    40,    41,
       0,     0,    42,     0,     0,    43,     0,     1,     2,     3,
       4,     5,     0,     0,    44,     6,     7,     0,     8,     0,
       9,   -16,     0,    10,    11,    12,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,    14,     0,     0,
      15,    16,    17,    18,    19,    20,     0,    21,    22,     0,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,     0,     0,     0,     0,     0,    32,    33,    34,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     0,    38,    39,    40,    41,
       0,     0,    42,     0,     0,    43,     0,     1,     2,     3,
       4,     5,     0,     0,    44,     6,     7,     0,     8,     0,
       9,   -17,     0,    10,    11,    12,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,    14,     0,     0,
      15,    16,    17,    18,    19,    20,     0,    21,    22,     0,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,     0,     0,     0,     0,     0,    32,    33,    34,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     0,    38,    39,    40,    41,
       0,     0,    42,     0,     0,    43,     0,     1,     2,     3,
       4,     5,     0,     0,    44,     6,     7,     0,     8,     0,
       9,     0,     0,    10,    11,    12,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,    14,     0,     0,
      15,    16,    17,    18,    19,    20,     0,    21,    22,     0,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,     0,     0,     0,     0,     0,    32,    33,    34,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     0,    38,    39,    40,    41,
       0,     0,    42,     0,     0,    43,     0,     1,     2,     3,
       4,     5,     0,     0,    44,     6,     7,     0,     8,     0,
       9,    92,     0,    10,    11,    12,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,    14,     0,     0,
      15,    16,    17,    18,    19,    20,     0,     0,    22,     0,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,     0,     0,     0,     0,     0,    32,    33,    34,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,    42,     0,     0,    43,     0,     1,     2,     3,
       4,     5,     0,     0,    44,     6,     7,     0,     8,     0,
       9,   195,     0,    10,    11,    12,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,    14,     0,     0,
      15,    16,    17,    18,    19,    20,     0,     0,    22,     0,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,     0,     0,     0,     0,     0,    32,    33,    34,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,    42,     0,     0,    43,     0,     1,     2,     3,
       4,     5,     0,     0,    44,     6,     7,     0,     8,     0,
       9,     0,     0,    10,    11,    12,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,    14,     0,     0,
      15,    16,    17,    18,    19,    20,     0,     0,    22,     0,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,     0,     0,     0,     0,     0,    32,    33,    34,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,    41,
     112,     0,    42,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,    44,     0,   339,   340,   341,   342,
     343,   344,   345,   410,   347,   348,   349,   350,   351,   352,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   353,   354,   355,   356,   357,   358,   359,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   360,
       0,     0,     0,     0,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,     0,
     376,     0,   377,   378,   379,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   380,   381,     0,     0,
     382,   383,   384,   385,     1,     2,     3,     4,     5,     0,
       0,     0,     0,     7,    89,     8,     0,     0,     0,     0,
      10,    11,    12,     0,     0,     0,     0,    13,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    23,     0,     0,
       0,    24,    25,     0,    26,    27,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    30,    31,     0,     0,
       0,     0,     0,     0,    32,    33,    34,    35,     1,     2,
       3,     4,     5,     0,     0,     0,   103,     7,     0,     8,
      36,     0,     0,     0,    10,    11,    12,     0,    37,     0,
       0,    13,     0,     0,     0,     0,    41,     0,     0,    42,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,    23,     0,     0,     0,    24,    25,     0,    26,    27,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      30,    31,     0,     0,     0,     0,     0,     0,    32,    33,
      34,    35,     1,     2,     3,     4,     5,     0,     0,     0,
       6,     7,     0,     8,    36,     0,     0,     0,    10,    11,
      12,     0,    37,     0,     0,    13,     0,     0,     0,     0,
      41,     0,     0,    42,     0,     0,    43,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,     0,     0,    24,
      25,     0,    26,    27,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    30,    31,     0,     0,     0,     0,
       0,     0,    32,    33,    34,    35,     1,     2,     3,     4,
       5,     0,     0,     0,     0,     7,   257,     8,    36,     0,
       0,     0,    10,    11,    12,     0,    37,     0,     0,    13,
       0,     0,     0,     0,    41,     0,     0,    42,     0,     0,
      43,     0,     0,     0,     0,     0,     0,     0,     0,    23,
       0,     0,     0,    24,    25,     0,    26,    27,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    30,    31,
       0,     0,     0,     0,     0,     0,    32,    33,    34,    35,
       0,     0,     0,     0,     0,     0,     1,     2,     3,     4,
       5,     0,    36,     0,     0,     7,     0,     8,   260,     0,
      37,     0,    10,    11,    12,     0,     0,     0,    41,    13,
       0,    42,     0,     0,    43,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    23,
       0,     0,     0,    24,    25,     0,    26,    27,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    30,    31,
       0,     0,     0,     0,     0,     0,    32,    33,    34,    35,
       1,     2,     3,     4,     5,     0,     0,     0,     0,     7,
     272,     8,    36,     0,     0,     0,    10,    11,    12,     0,
      37,     0,     0,    13,     0,     0,     0,     0,    41,     0,
       0,    42,     0,     0,    43,     0,     0,     0,     0,     0,
       0,     0,     0,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,     0,     0,     0,     0,     0,
      32,    33,    34,    35,     1,     2,     3,     4,     5,     0,
       0,     0,     0,     7,   274,     8,    36,     0,     0,     0,
      10,    11,    12,     0,    37,     0,     0,    13,     0,     0,
       0,     0,    41,     0,     0,    42,     0,     0,    43,     0,
       0,     0,     0,     0,     0,     0,     0,    23,     0,     0,
       0,    24,    25,     0,    26,    27,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    30,    31,     0,     0,
       0,     0,     0,     0,    32,    33,    34,    35,     0,     0,
       0,     0,     0,     0,     1,     2,     3,     4,     5,     0,
      36,     0,     0,     7,     0,     8,   276,     0,    37,     0,
      10,    11,    12,     0,     0,     0,    41,    13,     0,    42,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    23,     0,     0,
       0,    24,    25,     0,    26,    27,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    30,    31,     0,     0,
       0,     0,     0,     0,    32,    33,    34,    35,     1,     2,
       3,     4,     5,     0,     0,     0,     0,     7,   304,     8,
      36,     0,     0,     0,    10,    11,    12,     0,    37,     0,
       0,    13,     0,     0,     0,     0,    41,     0,     0,    42,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,    23,     0,     0,     0,    24,    25,     0,    26,    27,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      30,    31,     0,     0,     0,     0,     0,     0,    32,    33,
      34,    35,     1,     2,     3,     4,     5,     0,     0,     0,
       0,     7,     0,     8,    36,     0,     0,     0,    10,    11,
      12,     0,    37,     0,     0,    13,     0,     0,     0,     0,
      41,     0,     0,    42,     0,     0,    43,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,     0,     0,    24,
      25,     0,    26,    27,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    30,    31,     0,     0,     0,     0,
       0,     0,    32,    33,    34,    35,   105,     2,     3,     4,
       5,     0,     0,     0,     0,     7,     0,     8,    36,     0,
       0,     0,    10,    11,    12,     0,    37,     0,     0,     0,
       0,     0,     0,     0,    41,     0,     0,    42,     0,     0,
      43,     0,     0,     0,     0,     0,     0,     0,     0,    23,
       0,     0,     0,    24,    25,     0,    26,    27,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    32,    33,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,     0,     0,     0,     0,     0,     0,
      37,     0,     0,     0,     0,     0,     0,     0,   338,     0,
       0,    42,     0,     0,    43,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   353,   354,   355,   356,   357,   358,   359,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   360,     0,
       0,     0,     0,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,     0,   376,
       0,   377,   378,   379,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   380,   381,   433,     0,   382,
     383,   384,   385,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   353,   354,   355,   356,   357,   358,   359,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   360,     0,     0,
       0,     0,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,     0,   376,     0,
     377,   378,   379,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   380,   381,     0,     0,   382,   383,
     384,   385,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   353,
     354,   355,   356,   357,   358,   359,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   360,     0,     0,     0,     0,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,     0,   376,     0,   377,   378,
     379,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   380,   381,     0,     0,   382,   383,   384,   385
};

static const yytype_int16 yycheck[] =
{
      30,    31,    32,    17,    86,   131,     7,     8,   228,     3,
       9,    41,    53,   196,    98,   289,     3,     3,   292,   338,
      16,    22,   139,    16,    12,    26,    27,    28,   286,    36,
       0,    31,     0,   115,    24,    25,   118,     0,     3,    26,
      54,     9,    43,    33,    34,    45,     3,     3,    12,     9,
      14,     4,    11,    13,    18,     3,    13,    64,   332,    11,
     334,   335,     9,    16,    16,    13,    13,     3,   326,    26,
      26,   329,   113,   114,   294,    45,   193,    45,    26,    93,
     121,   122,    45,    71,    12,    71,    50,    51,     3,    76,
      26,     9,     3,    11,    84,    96,    97,    98,    13,   100,
     283,    11,    13,    11,   100,   101,   136,   100,    16,   428,
     111,    26,   194,   112,   433,    26,   200,   337,   338,    12,
     109,   110,     9,   117,   113,   114,   115,   116,    15,   105,
     106,     9,     9,   407,   408,    13,    13,     3,     4,     5,
       6,     7,   118,   119,    12,     9,    12,     9,    14,    13,
       3,    13,     9,   427,   184,   281,    13,    12,   284,     9,
     434,   287,   436,    13,   165,     9,     9,   441,   442,    13,
      13,     9,     9,    12,   256,    13,    13,   218,   260,    30,
       9,     9,    89,   403,    13,    13,   187,    53,    54,    55,
     272,     9,   274,   413,     9,    13,    11,   227,   228,    26,
      27,    28,    29,   172,   173,   174,   175,    21,    22,    23,
      12,   212,    14,   214,   215,   435,   399,    47,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    98,    99,
     312,    90,   314,    12,    93,    14,    95,    96,    97,     9,
      10,    11,   180,   181,   182,   111,    98,    99,    24,    25,
     264,   265,    98,    99,    87,    88,   270,   271,    19,    20,
       9,    10,   176,   177,   294,   266,   267,   268,   269,   170,
     171,    49,   398,   178,   179,    48,    89,    52,    18,    91,
      28,    71,     9,     4,     3,     3,    12,    12,    71,    17,
     304,    14,    12,    15,     9,    12,     9,    35,    14,   100,
      14,   101,     9,    12,    16,    16,    16,   337,   338,   323,
      13,    13,    17,    17,     0,    15,    13,     3,     4,     5,
       6,     7,    12,    11,    11,    11,    12,   230,    14,    13,
      16,    13,    17,    19,    20,    21,    17,    13,    12,    45,
      26,    13,    13,    13,   321,   280,    44,    33,   156,   290,
      36,    37,    38,    39,    40,    41,   163,    43,    44,   299,
      46,   164,   166,   168,    50,    51,   183,    53,    54,    55,
     167,   169,    -1,   403,   388,   186,   390,   391,    64,    65,
      66,    -1,    -1,   413,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,   435,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
      -1,    -1,   108,    -1,    -1,   111,    -1,     3,     4,     5,
       6,     7,    -1,    -1,   120,    11,    12,    -1,    14,    -1,
      16,    17,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    -1,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
      -1,    -1,   108,    -1,    -1,   111,    -1,     3,     4,     5,
       6,     7,    -1,    -1,   120,    11,    12,    -1,    14,    -1,
      16,    17,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    -1,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
      -1,    -1,   108,    -1,    -1,   111,    -1,     3,     4,     5,
       6,     7,    -1,    -1,   120,    11,    12,    -1,    14,    -1,
      16,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    -1,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
      -1,    -1,   108,    -1,    -1,   111,    -1,     3,     4,     5,
       6,     7,    -1,    -1,   120,    11,    12,    -1,    14,    -1,
      16,    17,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    -1,    -1,    44,    -1,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
      -1,    -1,   108,    -1,    -1,   111,    -1,     3,     4,     5,
       6,     7,    -1,    -1,   120,    11,    12,    -1,    14,    -1,
      16,    17,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    -1,    -1,    44,    -1,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
      -1,    -1,   108,    -1,    -1,   111,    -1,     3,     4,     5,
       6,     7,    -1,    -1,   120,    11,    12,    -1,    14,    -1,
      16,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    -1,    -1,    44,    -1,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
       3,    -1,   108,    -1,    -1,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    47,    48,    49,    50,    51,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,
      -1,    -1,    -1,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,    -1,
     113,   114,   115,   116,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    74,    75,    76,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    11,    12,    -1,    14,
      89,    -1,    -1,    -1,    19,    20,    21,    -1,    97,    -1,
      -1,    26,    -1,    -1,    -1,    -1,   105,    -1,    -1,   108,
      -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,
      75,    76,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      11,    12,    -1,    14,    89,    -1,    -1,    -1,    19,    20,
      21,    -1,    97,    -1,    -1,    26,    -1,    -1,    -1,    -1,
     105,    -1,    -1,   108,    -1,    -1,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    50,
      51,    -1,    53,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    74,    75,    76,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    89,    -1,
      -1,    -1,    19,    20,    21,    -1,    97,    -1,    -1,    26,
      -1,    -1,    -1,    -1,   105,    -1,    -1,   108,    -1,    -1,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,    -1,    89,    -1,    -1,    12,    -1,    14,    15,    -1,
      97,    -1,    19,    20,    21,    -1,    -1,    -1,   105,    26,
      -1,   108,    -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,    76,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    89,    -1,    -1,    -1,    19,    20,    21,    -1,
      97,    -1,    -1,    26,    -1,    -1,    -1,    -1,   105,    -1,
      -1,   108,    -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    74,    75,    76,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    89,    -1,    -1,    -1,
      19,    20,    21,    -1,    97,    -1,    -1,    26,    -1,    -1,
      -1,    -1,   105,    -1,    -1,   108,    -1,    -1,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,    -1,
      89,    -1,    -1,    12,    -1,    14,    15,    -1,    97,    -1,
      19,    20,    21,    -1,    -1,    -1,   105,    26,    -1,   108,
      -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    74,    75,    76,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      89,    -1,    -1,    -1,    19,    20,    21,    -1,    97,    -1,
      -1,    26,    -1,    -1,    -1,    -1,   105,    -1,    -1,   108,
      -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,
      75,    76,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    -1,    14,    89,    -1,    -1,    -1,    19,    20,
      21,    -1,    97,    -1,    -1,    26,    -1,    -1,    -1,    -1,
     105,    -1,    -1,   108,    -1,    -1,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    50,
      51,    -1,    53,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    74,    75,    76,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    -1,    14,    89,    -1,
      -1,    -1,    19,    20,    21,    -1,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,    -1,   108,    -1,    -1,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    -1,
      -1,   108,    -1,    -1,   111,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    47,    48,    49,    50,    51,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,
      -1,    -1,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    12,    -1,   113,
     114,   115,   116,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    47,    48,    49,    50,    51,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,
      -1,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    -1,
      95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,    -1,   113,   114,
     115,   116,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      47,    48,    49,    50,    51,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    -1,    95,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,    -1,   113,   114,   115,   116
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,    11,    12,    14,    16,
      19,    20,    21,    26,    33,    36,    37,    38,    39,    40,
      41,    43,    44,    46,    50,    51,    53,    54,    55,    64,
      65,    66,    73,    74,    75,    76,    89,    97,   102,   103,
     104,   105,   108,   111,   120,   122,   123,   124,   132,   133,
     134,   136,   137,   138,   141,   142,   143,   144,   145,   146,
     147,   150,   151,   152,   153,   154,   156,   159,   160,   161,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   180,   181,   182,    71,    13,
     151,   151,    17,   141,     3,   131,    12,    12,    12,   142,
      12,    11,    11,    11,   151,     3,   177,   177,   151,   151,
     151,    12,     3,   138,   138,   138,   177,   177,     3,   157,
     158,    76,   138,    89,   151,     4,    16,   149,     0,   123,
      98,    99,   105,   106,   118,   119,   135,   157,   142,     9,
      11,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    90,    93,    95,    96,    97,   162,   109,   110,   113,
     114,   115,   116,   163,    31,    45,    30,    47,    49,    48,
      24,    25,    26,    27,    28,    29,    87,    88,    19,    20,
      21,    22,    23,    89,    52,   177,    91,    12,    18,    50,
      51,   154,    13,     9,    15,    17,    18,    28,   151,   151,
     150,   151,    36,    64,   151,    11,    13,    13,    13,   151,
     157,   157,    12,   154,    12,    14,   154,   155,     9,   157,
     157,   112,   148,   149,     3,   130,   130,    12,    12,     3,
     138,   139,   152,   153,   156,   166,   151,   167,   168,   169,
     170,   171,   171,   172,   172,   172,   172,   173,   173,   174,
     174,   175,   175,   175,   176,   138,   181,    13,   151,     3,
      15,   154,   131,    71,    13,    13,   150,    10,    12,    12,
      13,    13,    13,   151,    13,   151,    15,    14,   157,    17,
       9,     9,    16,   100,   101,   125,    16,   100,   129,    13,
     138,   140,    13,   140,    12,    14,   155,     3,   117,    10,
      13,   154,   142,   142,    13,   151,   151,   151,   151,   142,
     142,   154,    13,   154,    13,    15,   148,   130,   124,   126,
     127,   128,   132,   141,   131,   130,    16,   126,   130,    16,
     146,   158,    13,   146,    13,    13,   140,    12,    12,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    46,    47,    48,    49,    50,    51,    52,
      72,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    93,    95,    96,    97,
     109,   110,   113,   114,   115,   116,   179,   164,    35,   142,
      13,    13,    13,    13,   154,   154,    17,   127,   101,   100,
     126,    17,   126,     9,   146,   146,   146,    13,    13,   140,
      26,   140,   179,    12,   142,   142,   142,    11,    11,   130,
     131,    17,    17,   140,   146,    11,   146,    13,    13,    13,
     140,    11,   146,    12,   179,    12,    13,   179,   146,   140,
     146,    13,    13,   146,   146
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   121,   122,   122,   123,   123,   123,   124,   124,   124,
     124,   125,   125,   125,   125,   126,   126,   127,   127,   128,
     128,   128,   129,   130,   130,   131,   131,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   133,   133,   133,   134,   134,   134,   134,   135,   135,
     135,   136,   136,   137,   137,   138,   138,   139,   139,   140,
     140,   141,   141,   142,   142,   142,   142,   142,   142,   143,
     143,   143,   143,   144,   144,   145,   145,   145,   145,   145,
     145,   145,   145,   146,   146,   147,   147,   148,   148,   149,
     150,   150,   151,   151,   152,   152,   153,   153,   154,   154,
     154,   154,   155,   155,   156,   156,   156,   156,   156,   156,
     156,   157,   157,   158,   158,   158,   158,   158,   158,   158,
     159,   160,   161,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   163,   163,
     163,   163,   163,   163,   164,   164,   165,   165,   166,   166,
     167,   167,   168,   168,   169,   169,   170,   170,   170,   171,
     171,   171,   171,   171,   172,   172,   172,   173,   173,   173,
     174,   174,   174,   174,   175,   175,   176,   176,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     178,   178,   178,   178,   178,   178,   178,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   180,   180,   181,   181,   181,   181,
     181,   181,   181,   182,   182,   182,   182,   182,   182,   182,
     182,   182,   182,   182,   182
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     6,     7,     6,
       7,     2,     4,     2,     4,     1,     0,     1,     2,     1,
       1,     1,     2,     1,     3,     1,     3,     8,     7,     7,
       6,     6,     5,     5,     6,     8,     7,     9,     9,    11,
      11,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       0,     1,     2,     3,     4,     1,     1,     1,     2,     2,
       4,     1,     2,     1,     1,     1,     1,     1,     1,     2,
       3,     2,     2,     5,     7,     5,     7,     6,     7,     7,
       5,     7,     5,     2,     3,     2,     4,     1,     3,     1,
       1,     2,     1,     3,     1,     3,     1,     3,     3,     4,
       4,     5,     2,     3,     1,     2,     3,     3,     3,     2,
       3,     1,     3,     1,     2,     2,     3,     4,     4,     5,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     3,     1,
       3,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     1,     3,     1,     3,     1,     2,
       2,     2,     2,     2,     2,     3,     4,     5,     5,     6,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     3,     4,
       3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* program: program_section  */
#line 211 "chuck.y"
                                            { (yyval.program) = g_program = new_program( (yyvsp[0].program_section), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2136 "chuck.tab.c"
    break;

  case 3: /* program: program program_section  */
#line 212 "chuck.y"
                                            { (yyval.program) = g_program = append_program( (yyvsp[-1].program), (yyvsp[0].program_section), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2142 "chuck.tab.c"
    break;

  case 4: /* program_section: statement_list  */
#line 216 "chuck.y"
                                            { (yyval.program_section) = new_section_stmt( (yyvsp[0].stmt_list), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2148 "chuck.tab.c"
    break;

  case 5: /* program_section: function_definition  */
#line 217 "chuck.y"
                                            { (yyval.program_section) = new_section_func_def( (yyvsp[0].func_def), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2154 "chuck.tab.c"
    break;

  case 6: /* program_section: class_definition  */
#line 218 "chuck.y"
                                            { (yyval.program_section) = new_section_class_def( (yyvsp[0].class_def), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2160 "chuck.tab.c"
    break;

  case 7: /* class_definition: class_decl CLASS id_list LBRACE class_body RBRACE  */
#line 223 "chuck.y"
            { (yyval.class_def) = new_class_def( (yyvsp[-5].ival), (yyvsp[-3].id_list), NULL, (yyvsp[-1].class_body), (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2166 "chuck.tab.c"
    break;

  case 8: /* class_definition: class_decl CLASS id_list class_ext LBRACE class_body RBRACE  */
#line 225 "chuck.y"
            { (yyval.class_def) = new_class_def( (yyvsp[-6].ival), (yyvsp[-4].id_list), (yyvsp[-3].class_ext), (yyvsp[-1].class_body), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2172 "chuck.tab.c"
    break;

  case 9: /* class_definition: class_decl INTERFACE id_list LBRACE class_body RBRACE  */
#line 227 "chuck.y"
            { (yyval.class_def) = new_iface_def( (yyvsp[-5].ival), (yyvsp[-3].id_list), NULL, (yyvsp[-1].class_body), (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2178 "chuck.tab.c"
    break;

  case 10: /* class_definition: class_decl INTERFACE id_list iface_ext LBRACE class_body RBRACE  */
#line 229 "chuck.y"
            { (yyval.class_def) = new_iface_def( (yyvsp[-6].ival), (yyvsp[-4].id_list), (yyvsp[-3].class_ext), (yyvsp[-1].class_body), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2184 "chuck.tab.c"
    break;

  case 11: /* class_ext: IMPLEMENTS id_list  */
#line 233 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( NULL, (yyvsp[0].id_list), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2190 "chuck.tab.c"
    break;

  case 12: /* class_ext: IMPLEMENTS id_list EXTENDS id_dot  */
#line 234 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[0].id_list), (yyvsp[-2].id_list), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2196 "chuck.tab.c"
    break;

  case 13: /* class_ext: EXTENDS id_dot  */
#line 235 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[0].id_list), NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2202 "chuck.tab.c"
    break;

  case 14: /* class_ext: EXTENDS id_dot IMPLEMENTS id_list  */
#line 236 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[-2].id_list), (yyvsp[0].id_list), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2208 "chuck.tab.c"
    break;

  case 15: /* class_body: class_body2  */
#line 240 "chuck.y"
                                            { (yyval.class_body) = (yyvsp[0].class_body); }
#line 2214 "chuck.tab.c"
    break;

  case 16: /* class_body: %empty  */
#line 241 "chuck.y"
                                                    { (yyval.class_body) = NULL; }
#line 2220 "chuck.tab.c"
    break;

  case 17: /* class_body2: class_section  */
#line 245 "chuck.y"
                                            { (yyval.class_body) = new_class_body( (yyvsp[0].program_section), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2226 "chuck.tab.c"
    break;

  case 18: /* class_body2: class_section class_body2  */
#line 246 "chuck.y"
                                            { (yyval.class_body) = prepend_class_body( (yyvsp[-1].program_section), (yyvsp[0].class_body), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2232 "chuck.tab.c"
    break;

  case 19: /* class_section: statement_list  */
#line 251 "chuck.y"
                                            { (yyval.program_section) = new_section_stmt( (yyvsp[0].stmt_list), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2238 "chuck.tab.c"
    break;

  case 20: /* class_section: function_definition  */
#line 252 "chuck.y"
                                            { (yyval.program_section) = new_section_func_def( (yyvsp[0].func_def), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2244 "chuck.tab.c"
    break;

  case 21: /* class_section: class_definition  */
#line 253 "chuck.y"
                                            { (yyval.program_section) = new_section_class_def( (yyvsp[0].class_def), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2250 "chuck.tab.c"
    break;

  case 22: /* iface_ext: EXTENDS id_list  */
#line 257 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( NULL, (yyvsp[0].id_list), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2256 "chuck.tab.c"
    break;

  case 23: /* id_list: ID  */
#line 261 "chuck.y"
                                            { (yyval.id_list) = new_id_list( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column  /*, &@1 */ ); }
#line 2262 "chuck.tab.c"
    break;

  case 24: /* id_list: ID COMMA id_list  */
#line 262 "chuck.y"
                                            { (yyval.id_list) = prepend_id_list( (yyvsp[-2].sval), (yyvsp[0].id_list), (yylsp[-2]).first_line, (yylsp[-2]).first_column  /*, &@1 */ ); }
#line 2268 "chuck.tab.c"
    break;

  case 25: /* id_dot: ID  */
#line 266 "chuck.y"
                                            { (yyval.id_list) = new_id_list( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column  /*, &@1*/ ); }
#line 2274 "chuck.tab.c"
    break;

  case 26: /* id_dot: ID DOT id_dot  */
#line 267 "chuck.y"
                                            { (yyval.id_list) = prepend_id_list( (yyvsp[-2].sval), (yyvsp[0].id_list), (yylsp[-2]).first_line, (yylsp[-2]).first_column  /*, &@1*/ ); }
#line 2280 "chuck.tab.c"
    break;

  case 27: /* function_definition: function_decl static_decl type_decl2 ID LPAREN arg_list RPAREN code_segment  */
#line 272 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-7].ival), (yyvsp[-6].ival), (yyvsp[-5].type_decl), (yyvsp[-4].sval), (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, (yylsp[-7]).first_line, (yylsp[-7]).first_column ); }
#line 2286 "chuck.tab.c"
    break;

  case 28: /* function_definition: function_decl static_decl type_decl2 ID LPAREN RPAREN code_segment  */
#line 274 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-6].ival), (yyvsp[-5].ival), (yyvsp[-4].type_decl), (yyvsp[-3].sval), NULL, (yyvsp[0].stmt), TRUE, (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2292 "chuck.tab.c"
    break;

  case 29: /* function_definition: function_decl static_decl ID LPAREN arg_list RPAREN code_segment  */
#line 276 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-6].ival), (yyvsp[-5].ival), NULL, (yyvsp[-4].sval), (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2298 "chuck.tab.c"
    break;

  case 30: /* function_definition: function_decl static_decl ID LPAREN RPAREN code_segment  */
#line 278 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-5].ival), (yyvsp[-4].ival), NULL, (yyvsp[-3].sval), NULL, (yyvsp[0].stmt), TRUE, (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2304 "chuck.tab.c"
    break;

  case 31: /* function_definition: function_decl AT_CTOR LPAREN arg_list RPAREN code_segment  */
#line 280 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-5].ival), ae_key_instance, NULL, "@construct", (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2310 "chuck.tab.c"
    break;

  case 32: /* function_definition: function_decl AT_CTOR LPAREN RPAREN code_segment  */
#line 282 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-4].ival), ae_key_instance, NULL, "@construct", NULL, (yyvsp[0].stmt), TRUE, (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2316 "chuck.tab.c"
    break;

  case 33: /* function_definition: function_decl AT_DTOR LPAREN RPAREN code_segment  */
#line 284 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-4].ival), ae_key_instance, NULL, "@destruct", NULL, (yyvsp[0].stmt), TRUE, (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2322 "chuck.tab.c"
    break;

  case 34: /* function_definition: function_decl AT_DTOR LPAREN arg_list RPAREN code_segment  */
#line 286 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-5].ival), ae_key_instance, NULL, "@destruct", (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2328 "chuck.tab.c"
    break;

  case 35: /* function_definition: function_decl static_decl type_decl2 ID LPAREN arg_list RPAREN SEMICOLON  */
#line 288 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-7].ival), (yyvsp[-6].ival), (yyvsp[-5].type_decl), (yyvsp[-4].sval), (yyvsp[-2].arg_list), NULL, TRUE, (yylsp[-7]).first_line, (yylsp[-7]).first_column ); }
#line 2334 "chuck.tab.c"
    break;

  case 36: /* function_definition: function_decl static_decl type_decl2 ID LPAREN RPAREN SEMICOLON  */
#line 290 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-6].ival), (yyvsp[-5].ival), (yyvsp[-4].type_decl), (yyvsp[-3].sval), NULL, NULL, TRUE, (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2340 "chuck.tab.c"
    break;

  case 37: /* function_definition: function_decl static_decl type_decl2 AT_OP overloadable_operator LPAREN arg_list RPAREN code_segment  */
#line 292 "chuck.y"
            { (yyval.func_def) = new_op_overload( (yyvsp[-8].ival), (yyvsp[-7].ival), (yyvsp[-6].type_decl), (yyvsp[-4].ival), (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, FALSE, (yylsp[-8]).first_line, (yylsp[-8]).first_column, (yylsp[-4]).first_column ); }
#line 2346 "chuck.tab.c"
    break;

  case 38: /* function_definition: function_decl static_decl type_decl2 AT_OP LPAREN arg_list RPAREN overloadable_operator code_segment  */
#line 294 "chuck.y"
            { (yyval.func_def) = new_op_overload( (yyvsp[-8].ival), (yyvsp[-7].ival), (yyvsp[-6].type_decl), (yyvsp[-1].ival), (yyvsp[-3].arg_list), (yyvsp[0].stmt), TRUE, TRUE, (yylsp[-8]).first_line, (yylsp[-8]).first_column, (yylsp[-1]).first_column ); }
#line 2352 "chuck.tab.c"
    break;

  case 39: /* function_definition: function_decl static_decl type_decl2 AT_OP LPAREN overloadable_operator RPAREN LPAREN arg_list RPAREN code_segment  */
#line 296 "chuck.y"
            { (yyval.func_def) = new_op_overload( (yyvsp[-10].ival), (yyvsp[-9].ival), (yyvsp[-8].type_decl), (yyvsp[-5].ival), (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, FALSE, (yylsp[-10]).first_line, (yylsp[-10]).first_column, (yylsp[-6]).first_column ); }
#line 2358 "chuck.tab.c"
    break;

  case 40: /* function_definition: function_decl static_decl type_decl2 AT_OP LPAREN arg_list RPAREN LPAREN overloadable_operator RPAREN code_segment  */
#line 298 "chuck.y"
            { (yyval.func_def) = new_op_overload( (yyvsp[-10].ival), (yyvsp[-9].ival), (yyvsp[-8].type_decl), (yyvsp[-2].ival), (yyvsp[-5].arg_list), (yyvsp[0].stmt), TRUE, TRUE, (yylsp[-10]).first_line, (yylsp[-10]).first_column, (yylsp[-3]).first_column ); }
#line 2364 "chuck.tab.c"
    break;

  case 41: /* class_decl: PUBLIC  */
#line 302 "chuck.y"
                                            { (yyval.ival) = ae_key_public; }
#line 2370 "chuck.tab.c"
    break;

  case 42: /* class_decl: PRIVATE  */
#line 303 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 2376 "chuck.tab.c"
    break;

  case 43: /* class_decl: %empty  */
#line 304 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 2382 "chuck.tab.c"
    break;

  case 44: /* function_decl: FUNCTION  */
#line 308 "chuck.y"
                                            { (yyval.ival) = ae_key_func; }
#line 2388 "chuck.tab.c"
    break;

  case 45: /* function_decl: PUBLIC  */
#line 309 "chuck.y"
                                            { (yyval.ival) = ae_key_public; }
#line 2394 "chuck.tab.c"
    break;

  case 46: /* function_decl: PROTECTED  */
#line 310 "chuck.y"
                                            { (yyval.ival) = ae_key_protected; }
#line 2400 "chuck.tab.c"
    break;

  case 47: /* function_decl: PRIVATE  */
#line 311 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 2406 "chuck.tab.c"
    break;

  case 48: /* static_decl: STATIC  */
#line 315 "chuck.y"
                                            { (yyval.ival) = ae_key_static; }
#line 2412 "chuck.tab.c"
    break;

  case 49: /* static_decl: ABSTRACT  */
#line 316 "chuck.y"
                                            { (yyval.ival) = ae_key_abstract; }
#line 2418 "chuck.tab.c"
    break;

  case 50: /* static_decl: %empty  */
#line 317 "chuck.y"
                                            { (yyval.ival) = ae_key_instance; }
#line 2424 "chuck.tab.c"
    break;

  case 51: /* type_decl_a: ID  */
#line 321 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( new_id_list( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column /*, &@1*/ ), 0, (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2430 "chuck.tab.c"
    break;

  case 52: /* type_decl_a: ID AT_SYM  */
#line 322 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( new_id_list( (yyvsp[-1].sval), (yylsp[-1]).first_line, (yylsp[-1]).first_column /*, &@1*/ ), 1, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2436 "chuck.tab.c"
    break;

  case 53: /* type_decl_b: LT id_dot GT  */
#line 326 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( (yyvsp[-1].id_list), 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2442 "chuck.tab.c"
    break;

  case 54: /* type_decl_b: LT id_dot GT AT_SYM  */
#line 327 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( (yyvsp[-2].id_list), 1, (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2448 "chuck.tab.c"
    break;

  case 55: /* type_decl: type_decl_a  */
#line 336 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 2454 "chuck.tab.c"
    break;

  case 56: /* type_decl: type_decl_b  */
#line 337 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 2460 "chuck.tab.c"
    break;

  case 57: /* type_decl2: type_decl  */
#line 342 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 2466 "chuck.tab.c"
    break;

  case 58: /* type_decl2: type_decl array_empty  */
#line 343 "chuck.y"
                                            { (yyval.type_decl) = add_type_decl_array( (yyvsp[-1].type_decl), (yyvsp[0].array_sub), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2472 "chuck.tab.c"
    break;

  case 59: /* arg_list: type_decl var_decl  */
#line 347 "chuck.y"
                                            { (yyval.arg_list) = new_arg_list( (yyvsp[-1].type_decl), (yyvsp[0].var_decl), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2478 "chuck.tab.c"
    break;

  case 60: /* arg_list: type_decl var_decl COMMA arg_list  */
#line 348 "chuck.y"
                                            { (yyval.arg_list) = prepend_arg_list( (yyvsp[-3].type_decl), (yyvsp[-2].var_decl), (yyvsp[0].arg_list), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2484 "chuck.tab.c"
    break;

  case 61: /* statement_list: statement  */
#line 352 "chuck.y"
                                            { (yyval.stmt_list) = new_stmt_list( (yyvsp[0].stmt), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2490 "chuck.tab.c"
    break;

  case 62: /* statement_list: statement_list statement  */
#line 353 "chuck.y"
                                            { (yyval.stmt_list) = append_stmt_list( (yyvsp[-1].stmt_list), (yyvsp[0].stmt), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2496 "chuck.tab.c"
    break;

  case 63: /* statement: expression_statement  */
#line 357 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2502 "chuck.tab.c"
    break;

  case 64: /* statement: loop_statement  */
#line 358 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2508 "chuck.tab.c"
    break;

  case 65: /* statement: selection_statement  */
#line 359 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2514 "chuck.tab.c"
    break;

  case 66: /* statement: jump_statement  */
#line 360 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2520 "chuck.tab.c"
    break;

  case 67: /* statement: code_segment  */
#line 362 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2526 "chuck.tab.c"
    break;

  case 68: /* statement: import_statement  */
#line 363 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2532 "chuck.tab.c"
    break;

  case 69: /* jump_statement: RETURN SEMICOLON  */
#line 367 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_return( NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2538 "chuck.tab.c"
    break;

  case 70: /* jump_statement: RETURN expression SEMICOLON  */
#line 368 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_return( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2544 "chuck.tab.c"
    break;

  case 71: /* jump_statement: BREAK SEMICOLON  */
#line 369 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_break( (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2550 "chuck.tab.c"
    break;

  case 72: /* jump_statement: CONTINUE SEMICOLON  */
#line 370 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_continue( (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2556 "chuck.tab.c"
    break;

  case 73: /* selection_statement: IF LPAREN expression RPAREN statement  */
#line 375 "chuck.y"
            { (yyval.stmt) = new_stmt_from_if( (yyvsp[-2].exp), (yyvsp[0].stmt), NULL, (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2562 "chuck.tab.c"
    break;

  case 74: /* selection_statement: IF LPAREN expression RPAREN statement ELSE statement  */
#line 377 "chuck.y"
            { (yyval.stmt) = new_stmt_from_if( (yyvsp[-4].exp), (yyvsp[-2].stmt), (yyvsp[0].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2568 "chuck.tab.c"
    break;

  case 75: /* loop_statement: WHILE LPAREN expression RPAREN statement  */
#line 382 "chuck.y"
            { (yyval.stmt) = new_stmt_from_while( (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2574 "chuck.tab.c"
    break;

  case 76: /* loop_statement: DO statement WHILE LPAREN expression RPAREN SEMICOLON  */
#line 384 "chuck.y"
            { (yyval.stmt) = new_stmt_from_do_while( (yyvsp[-2].exp), (yyvsp[-5].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2580 "chuck.tab.c"
    break;

  case 77: /* loop_statement: FOR LPAREN expression_statement expression_statement RPAREN statement  */
#line 386 "chuck.y"
            { (yyval.stmt) = new_stmt_from_for( (yyvsp[-3].stmt), (yyvsp[-2].stmt), NULL, (yyvsp[0].stmt), (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2586 "chuck.tab.c"
    break;

  case 78: /* loop_statement: FOR LPAREN expression_statement expression_statement expression RPAREN statement  */
#line 388 "chuck.y"
            { (yyval.stmt) = new_stmt_from_for( (yyvsp[-4].stmt), (yyvsp[-3].stmt), (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2592 "chuck.tab.c"
    break;

  case 79: /* loop_statement: FOR LPAREN expression COLON expression RPAREN statement  */
#line 390 "chuck.y"
            { (yyval.stmt) = new_stmt_from_foreach( (yyvsp[-4].exp), (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2598 "chuck.tab.c"
    break;

  case 80: /* loop_statement: UNTIL LPAREN expression RPAREN statement  */
#line 392 "chuck.y"
            { (yyval.stmt) = new_stmt_from_until( (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2604 "chuck.tab.c"
    break;

  case 81: /* loop_statement: DO statement UNTIL LPAREN expression RPAREN SEMICOLON  */
#line 394 "chuck.y"
            { (yyval.stmt) = new_stmt_from_do_until( (yyvsp[-2].exp), (yyvsp[-5].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2610 "chuck.tab.c"
    break;

  case 82: /* loop_statement: LOOP LPAREN expression RPAREN statement  */
#line 396 "chuck.y"
            { (yyval.stmt) = new_stmt_from_loop( (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2616 "chuck.tab.c"
    break;

  case 83: /* code_segment: LBRACE RBRACE  */
#line 400 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_code( NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2622 "chuck.tab.c"
    break;

  case 84: /* code_segment: LBRACE statement_list RBRACE  */
#line 401 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_code( (yyvsp[-1].stmt_list), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2628 "chuck.tab.c"
    break;

  case 85: /* import_statement: AT_IMPORT import_target  */
#line 405 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_import( (yyvsp[0].import), (yylsp[-1]).first_line, (yylsp[-1]).first_column );}
#line 2634 "chuck.tab.c"
    break;

  case 86: /* import_statement: AT_IMPORT LBRACE import_list RBRACE  */
#line 406 "chuck.y"
                                              { (yyval.stmt) = new_stmt_from_import( (yyvsp[-1].import), (yylsp[-3]).first_line, (yylsp[-3]).first_column );}
#line 2640 "chuck.tab.c"
    break;

  case 87: /* import_list: import_target  */
#line 410 "chuck.y"
                                            { (yyval.import) = (yyvsp[0].import); }
#line 2646 "chuck.tab.c"
    break;

  case 88: /* import_list: import_target COMMA import_list  */
#line 411 "chuck.y"
                                            { (yyval.import) = prepend_import( (yyvsp[-2].import), (yyvsp[0].import), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2652 "chuck.tab.c"
    break;

  case 89: /* import_target: STRING_LIT  */
#line 414 "chuck.y"
                                            { (yyval.import) = new_import( (yyvsp[0].sval), NULL, (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2658 "chuck.tab.c"
    break;

  case 90: /* expression_statement: SEMICOLON  */
#line 419 "chuck.y"
                                            { (yyval.stmt) = NULL; }
#line 2664 "chuck.tab.c"
    break;

  case 91: /* expression_statement: expression SEMICOLON  */
#line 420 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_expression( (yyvsp[-1].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2670 "chuck.tab.c"
    break;

  case 92: /* expression: chuck_expression  */
#line 424 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2676 "chuck.tab.c"
    break;

  case 93: /* expression: expression COMMA chuck_expression  */
#line 425 "chuck.y"
                                            { (yyval.exp) = append_expression( (yyvsp[-2].exp), (yyvsp[0].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2682 "chuck.tab.c"
    break;

  case 94: /* chuck_expression: arrow_expression  */
#line 429 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2688 "chuck.tab.c"
    break;

  case 95: /* chuck_expression: chuck_expression chuck_operator arrow_expression  */
#line 431 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), (yyvsp[-1].ival), (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2694 "chuck.tab.c"
    break;

  case 96: /* arrow_expression: decl_expression  */
#line 435 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2700 "chuck.tab.c"
    break;

  case 97: /* arrow_expression: arrow_expression arrow_operator decl_expression  */
#line 437 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), (yyvsp[-1].ival), (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2706 "chuck.tab.c"
    break;

  case 98: /* array_exp: LBRACK expression RBRACK  */
#line 441 "chuck.y"
                                            { (yyval.array_sub) = new_array_sub( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2712 "chuck.tab.c"
    break;

  case 99: /* array_exp: LBRACK expression COMMA RBRACK  */
#line 442 "chuck.y"
                                            { (yyval.array_sub) = new_array_sub( (yyvsp[-2].exp), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2718 "chuck.tab.c"
    break;

  case 100: /* array_exp: LBRACK expression RBRACK array_exp  */
#line 444 "chuck.y"
            { (yyval.array_sub) = prepend_array_sub( (yyvsp[0].array_sub), (yyvsp[-2].exp), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2724 "chuck.tab.c"
    break;

  case 101: /* array_exp: LBRACK expression COMMA RBRACK array_exp  */
#line 446 "chuck.y"
            { (yyval.array_sub) = prepend_array_sub( (yyvsp[0].array_sub), (yyvsp[-3].exp), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2730 "chuck.tab.c"
    break;

  case 102: /* array_empty: LBRACK RBRACK  */
#line 450 "chuck.y"
                                            { (yyval.array_sub) = new_array_sub( NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2736 "chuck.tab.c"
    break;

  case 103: /* array_empty: array_empty LBRACK RBRACK  */
#line 451 "chuck.y"
                                            { (yyval.array_sub) = prepend_array_sub( (yyvsp[-2].array_sub), NULL, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2742 "chuck.tab.c"
    break;

  case 104: /* decl_expression: conditional_expression  */
#line 455 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2748 "chuck.tab.c"
    break;

  case 105: /* decl_expression: type_decl var_decl_list  */
#line 456 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, 0, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2754 "chuck.tab.c"
    break;

  case 106: /* decl_expression: EXTERNAL type_decl var_decl_list  */
#line 457 "chuck.y"
                                            { (yyval.exp) = new_exp_decl_external( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2760 "chuck.tab.c"
    break;

  case 107: /* decl_expression: GLOBAL type_decl var_decl_list  */
#line 458 "chuck.y"
                                            { (yyval.exp) = new_exp_decl_global( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2766 "chuck.tab.c"
    break;

  case 108: /* decl_expression: STATIC type_decl var_decl_list  */
#line 459 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 1, 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2772 "chuck.tab.c"
    break;

  case 109: /* decl_expression: SAME var_decl_list  */
#line 460 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( NULL, (yyvsp[0].var_decl_list), 0, 0, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2778 "chuck.tab.c"
    break;

  case 110: /* decl_expression: STATIC SAME var_decl_list  */
#line 461 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( NULL, (yyvsp[0].var_decl_list), 1, 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2784 "chuck.tab.c"
    break;

  case 111: /* var_decl_list: var_decl  */
#line 465 "chuck.y"
                                            { (yyval.var_decl_list) = new_var_decl_list( (yyvsp[0].var_decl), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2790 "chuck.tab.c"
    break;

  case 112: /* var_decl_list: var_decl COMMA var_decl_list  */
#line 466 "chuck.y"
                                            { (yyval.var_decl_list) = prepend_var_decl_list( (yyvsp[-2].var_decl), (yyvsp[0].var_decl_list), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2796 "chuck.tab.c"
    break;

  case 113: /* var_decl: ID  */
#line 470 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[0].sval), FALSE, NULL, NULL, (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2802 "chuck.tab.c"
    break;

  case 114: /* var_decl: ID array_exp  */
#line 471 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-1].sval), FALSE, NULL, (yyvsp[0].array_sub), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2808 "chuck.tab.c"
    break;

  case 115: /* var_decl: ID array_empty  */
#line 472 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-1].sval), FALSE, NULL, (yyvsp[0].array_sub), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2814 "chuck.tab.c"
    break;

  case 116: /* var_decl: ID LPAREN RPAREN  */
#line 473 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-2].sval), TRUE, NULL, NULL, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2820 "chuck.tab.c"
    break;

  case 117: /* var_decl: ID LPAREN expression RPAREN  */
#line 474 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-3].sval), TRUE, (yyvsp[-1].exp), NULL, (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2826 "chuck.tab.c"
    break;

  case 118: /* var_decl: ID LPAREN RPAREN array_exp  */
#line 475 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-3].sval), TRUE, NULL, (yyvsp[0].array_sub), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2832 "chuck.tab.c"
    break;

  case 119: /* var_decl: ID LPAREN expression RPAREN array_exp  */
#line 476 "chuck.y"
                                                 { (yyval.var_decl) = new_var_decl( (yyvsp[-4].sval), TRUE, (yyvsp[-2].exp), (yyvsp[0].array_sub), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2838 "chuck.tab.c"
    break;

  case 120: /* complex_exp: POUNDPAREN expression RPAREN  */
#line 481 "chuck.y"
            { (yyval.complex_exp) = new_complex( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2844 "chuck.tab.c"
    break;

  case 121: /* polar_exp: PERCENTPAREN expression RPAREN  */
#line 486 "chuck.y"
            { (yyval.polar_exp) = new_polar( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2850 "chuck.tab.c"
    break;

  case 122: /* vec_exp: ATPAREN expression RPAREN  */
#line 491 "chuck.y"
            { (yyval.vec_exp) = new_vec( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2856 "chuck.tab.c"
    break;

  case 123: /* chuck_operator: CHUCK  */
#line 495 "chuck.y"
                                            { (yyval.ival) = ae_op_chuck; }
#line 2862 "chuck.tab.c"
    break;

  case 124: /* chuck_operator: AT_CHUCK  */
#line 496 "chuck.y"
                                            { (yyval.ival) = ae_op_at_chuck; }
#line 2868 "chuck.tab.c"
    break;

  case 125: /* chuck_operator: PLUS_CHUCK  */
#line 497 "chuck.y"
                                            { (yyval.ival) = ae_op_plus_chuck; }
#line 2874 "chuck.tab.c"
    break;

  case 126: /* chuck_operator: MINUS_CHUCK  */
#line 498 "chuck.y"
                                            { (yyval.ival) = ae_op_minus_chuck; }
#line 2880 "chuck.tab.c"
    break;

  case 127: /* chuck_operator: TIMES_CHUCK  */
#line 499 "chuck.y"
                                            { (yyval.ival) = ae_op_times_chuck; }
#line 2886 "chuck.tab.c"
    break;

  case 128: /* chuck_operator: DIVIDE_CHUCK  */
#line 500 "chuck.y"
                                            { (yyval.ival) = ae_op_divide_chuck; }
#line 2892 "chuck.tab.c"
    break;

  case 129: /* chuck_operator: SHIFT_RIGHT_CHUCK  */
#line 501 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_right_chuck; }
#line 2898 "chuck.tab.c"
    break;

  case 130: /* chuck_operator: SHIFT_LEFT_CHUCK  */
#line 502 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_left_chuck; }
#line 2904 "chuck.tab.c"
    break;

  case 131: /* chuck_operator: PERCENT_CHUCK  */
#line 503 "chuck.y"
                                            { (yyval.ival) = ae_op_percent_chuck; }
#line 2910 "chuck.tab.c"
    break;

  case 132: /* chuck_operator: UNCHUCK  */
#line 504 "chuck.y"
                                            { (yyval.ival) = ae_op_unchuck; }
#line 2916 "chuck.tab.c"
    break;

  case 133: /* chuck_operator: UPCHUCK  */
#line 505 "chuck.y"
                                            { (yyval.ival) = ae_op_upchuck; }
#line 2922 "chuck.tab.c"
    break;

  case 134: /* chuck_operator: DOWNCHUCK  */
#line 506 "chuck.y"
                                            { (yyval.ival) = ae_op_downchuck; }
#line 2928 "chuck.tab.c"
    break;

  case 135: /* chuck_operator: S_AND_CHUCK  */
#line 507 "chuck.y"
                                            { (yyval.ival) = ae_op_s_and_chuck; }
#line 2934 "chuck.tab.c"
    break;

  case 136: /* chuck_operator: S_OR_CHUCK  */
#line 508 "chuck.y"
                                            { (yyval.ival) = ae_op_s_or_chuck; }
#line 2940 "chuck.tab.c"
    break;

  case 137: /* chuck_operator: S_XOR_CHUCK  */
#line 509 "chuck.y"
                                            { (yyval.ival) = ae_op_s_xor_chuck; }
#line 2946 "chuck.tab.c"
    break;

  case 138: /* arrow_operator: ARROW_LEFT  */
#line 513 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_left; }
#line 2952 "chuck.tab.c"
    break;

  case 139: /* arrow_operator: ARROW_RIGHT  */
#line 514 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_right; }
#line 2958 "chuck.tab.c"
    break;

  case 140: /* arrow_operator: GRUCK_LEFT  */
#line 515 "chuck.y"
                                            { (yyval.ival) = ae_op_gruck_left; }
#line 2964 "chuck.tab.c"
    break;

  case 141: /* arrow_operator: GRUCK_RIGHT  */
#line 516 "chuck.y"
                                            { (yyval.ival) = ae_op_gruck_right; }
#line 2970 "chuck.tab.c"
    break;

  case 142: /* arrow_operator: UNGRUCK_LEFT  */
#line 517 "chuck.y"
                                            { (yyval.ival) = ae_op_ungruck_left; }
#line 2976 "chuck.tab.c"
    break;

  case 143: /* arrow_operator: UNGRUCK_RIGHT  */
#line 518 "chuck.y"
                                            { (yyval.ival) = ae_op_ungruck_right; }
#line 2982 "chuck.tab.c"
    break;

  case 144: /* conditional_expression: logical_or_expression  */
#line 522 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2988 "chuck.tab.c"
    break;

  case 145: /* conditional_expression: logical_or_expression QUESTION expression COLON conditional_expression  */
#line 524 "chuck.y"
            { (yyval.exp) = new_exp_from_if( (yyvsp[-4].exp), (yyvsp[-2].exp), (yyvsp[0].exp), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2994 "chuck.tab.c"
    break;

  case 146: /* logical_or_expression: logical_and_expression  */
#line 528 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3000 "chuck.tab.c"
    break;

  case 147: /* logical_or_expression: logical_or_expression OR logical_and_expression  */
#line 530 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_or, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3006 "chuck.tab.c"
    break;

  case 148: /* logical_and_expression: inclusive_or_expression  */
#line 534 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3012 "chuck.tab.c"
    break;

  case 149: /* logical_and_expression: logical_and_expression AND inclusive_or_expression  */
#line 536 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_and, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3018 "chuck.tab.c"
    break;

  case 150: /* inclusive_or_expression: exclusive_or_expression  */
#line 540 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3024 "chuck.tab.c"
    break;

  case 151: /* inclusive_or_expression: inclusive_or_expression S_OR exclusive_or_expression  */
#line 542 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_or, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3030 "chuck.tab.c"
    break;

  case 152: /* exclusive_or_expression: and_expression  */
#line 546 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3036 "chuck.tab.c"
    break;

  case 153: /* exclusive_or_expression: exclusive_or_expression S_XOR and_expression  */
#line 548 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_xor, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3042 "chuck.tab.c"
    break;

  case 154: /* and_expression: equality_expression  */
#line 552 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3048 "chuck.tab.c"
    break;

  case 155: /* and_expression: and_expression S_AND equality_expression  */
#line 554 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_and, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3054 "chuck.tab.c"
    break;

  case 156: /* equality_expression: relational_expression  */
#line 558 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3060 "chuck.tab.c"
    break;

  case 157: /* equality_expression: equality_expression EQ relational_expression  */
#line 560 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_eq, (yyvsp[0].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3066 "chuck.tab.c"
    break;

  case 158: /* equality_expression: equality_expression NEQ relational_expression  */
#line 562 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_neq, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3072 "chuck.tab.c"
    break;

  case 159: /* relational_expression: shift_expression  */
#line 566 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3078 "chuck.tab.c"
    break;

  case 160: /* relational_expression: relational_expression LT shift_expression  */
#line 568 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_lt, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3084 "chuck.tab.c"
    break;

  case 161: /* relational_expression: relational_expression GT shift_expression  */
#line 570 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_gt, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3090 "chuck.tab.c"
    break;

  case 162: /* relational_expression: relational_expression LE shift_expression  */
#line 572 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_le, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3096 "chuck.tab.c"
    break;

  case 163: /* relational_expression: relational_expression GE shift_expression  */
#line 574 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_ge, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3102 "chuck.tab.c"
    break;

  case 164: /* shift_expression: additive_expression  */
#line 578 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3108 "chuck.tab.c"
    break;

  case 165: /* shift_expression: shift_expression SHIFT_LEFT additive_expression  */
#line 580 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_shift_left, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3114 "chuck.tab.c"
    break;

  case 166: /* shift_expression: shift_expression SHIFT_RIGHT additive_expression  */
#line 582 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_shift_right, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3120 "chuck.tab.c"
    break;

  case 167: /* additive_expression: multiplicative_expression  */
#line 586 "chuck.y"
                                             { (yyval.exp) = (yyvsp[0].exp); }
#line 3126 "chuck.tab.c"
    break;

  case 168: /* additive_expression: additive_expression PLUS multiplicative_expression  */
#line 588 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_plus, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3132 "chuck.tab.c"
    break;

  case 169: /* additive_expression: additive_expression MINUS multiplicative_expression  */
#line 590 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_minus, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3138 "chuck.tab.c"
    break;

  case 170: /* multiplicative_expression: tilda_expression  */
#line 594 "chuck.y"
                                             { (yyval.exp) = (yyvsp[0].exp); }
#line 3144 "chuck.tab.c"
    break;

  case 171: /* multiplicative_expression: multiplicative_expression TIMES tilda_expression  */
#line 596 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_times, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3150 "chuck.tab.c"
    break;

  case 172: /* multiplicative_expression: multiplicative_expression DIVIDE tilda_expression  */
#line 598 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_divide, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3156 "chuck.tab.c"
    break;

  case 173: /* multiplicative_expression: multiplicative_expression PERCENT tilda_expression  */
#line 600 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_percent, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3162 "chuck.tab.c"
    break;

  case 174: /* tilda_expression: cast_expression  */
#line 604 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3168 "chuck.tab.c"
    break;

  case 175: /* tilda_expression: tilda_expression TILDA cast_expression  */
#line 606 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_tilda, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3174 "chuck.tab.c"
    break;

  case 176: /* cast_expression: unary_expression  */
#line 610 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3180 "chuck.tab.c"
    break;

  case 177: /* cast_expression: cast_expression DOLLAR type_decl  */
#line 612 "chuck.y"
            { (yyval.exp) = new_exp_from_cast( (yyvsp[0].type_decl), (yyvsp[-2].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column, (yylsp[-1]).first_column ); }
#line 3186 "chuck.tab.c"
    break;

  case 178: /* unary_expression: dur_expression  */
#line 616 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3192 "chuck.tab.c"
    break;

  case 179: /* unary_expression: PLUSPLUS unary_expression  */
#line 618 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_plusplus, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3198 "chuck.tab.c"
    break;

  case 180: /* unary_expression: MINUSMINUS unary_expression  */
#line 620 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_minusminus, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3204 "chuck.tab.c"
    break;

  case 181: /* unary_expression: unary_operator unary_expression  */
#line 622 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( (yyvsp[-1].ival), (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3210 "chuck.tab.c"
    break;

  case 182: /* unary_expression: TYPEOF unary_expression  */
#line 624 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_typeof, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3216 "chuck.tab.c"
    break;

  case 183: /* unary_expression: SIZEOF unary_expression  */
#line 626 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_sizeof, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3222 "chuck.tab.c"
    break;

  case 184: /* unary_expression: NEW type_decl  */
#line 628 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[0].type_decl), FALSE, NULL, NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3228 "chuck.tab.c"
    break;

  case 185: /* unary_expression: NEW type_decl array_exp  */
#line 630 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-1].type_decl), FALSE, NULL, (yyvsp[0].array_sub), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3234 "chuck.tab.c"
    break;

  case 186: /* unary_expression: NEW type_decl LPAREN RPAREN  */
#line 632 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-2].type_decl), TRUE, NULL, NULL, (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 3240 "chuck.tab.c"
    break;

  case 187: /* unary_expression: NEW type_decl LPAREN expression RPAREN  */
#line 634 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-3].type_decl), TRUE, (yyvsp[-1].exp), NULL, (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 3246 "chuck.tab.c"
    break;

  case 188: /* unary_expression: NEW type_decl LPAREN RPAREN array_exp  */
#line 636 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-3].type_decl), TRUE, NULL, (yyvsp[0].array_sub), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 3252 "chuck.tab.c"
    break;

  case 189: /* unary_expression: NEW type_decl LPAREN expression RPAREN array_exp  */
#line 638 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-4].type_decl), TRUE, (yyvsp[-2].exp), (yyvsp[0].array_sub), (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 3258 "chuck.tab.c"
    break;

  case 190: /* unary_operator: PLUS  */
#line 644 "chuck.y"
                                            { (yyval.ival) = ae_op_plus; }
#line 3264 "chuck.tab.c"
    break;

  case 191: /* unary_operator: MINUS  */
#line 645 "chuck.y"
                                            { (yyval.ival) = ae_op_minus; }
#line 3270 "chuck.tab.c"
    break;

  case 192: /* unary_operator: TILDA  */
#line 646 "chuck.y"
                                            { (yyval.ival) = ae_op_tilda; }
#line 3276 "chuck.tab.c"
    break;

  case 193: /* unary_operator: EXCLAMATION  */
#line 647 "chuck.y"
                                            { (yyval.ival) = ae_op_exclamation; }
#line 3282 "chuck.tab.c"
    break;

  case 194: /* unary_operator: TIMES  */
#line 648 "chuck.y"
                                            { (yyval.ival) = ae_op_times; }
#line 3288 "chuck.tab.c"
    break;

  case 195: /* unary_operator: SPORK TILDA  */
#line 649 "chuck.y"
                                            { (yyval.ival) = ae_op_spork; }
#line 3294 "chuck.tab.c"
    break;

  case 196: /* unary_operator: DOWNCHUCK  */
#line 650 "chuck.y"
                                            { (yyval.ival) = ae_op_downchuck; }
#line 3300 "chuck.tab.c"
    break;

  case 197: /* overloadable_operator: CHUCK  */
#line 656 "chuck.y"
                                            { (yyval.ival) = ae_op_chuck; }
#line 3306 "chuck.tab.c"
    break;

  case 198: /* overloadable_operator: PLUS  */
#line 657 "chuck.y"
                                            { (yyval.ival) = ae_op_plus; }
#line 3312 "chuck.tab.c"
    break;

  case 199: /* overloadable_operator: MINUS  */
#line 658 "chuck.y"
                                            { (yyval.ival) = ae_op_minus; }
#line 3318 "chuck.tab.c"
    break;

  case 200: /* overloadable_operator: TIMES  */
#line 659 "chuck.y"
                                            { (yyval.ival) = ae_op_times; }
#line 3324 "chuck.tab.c"
    break;

  case 201: /* overloadable_operator: DIVIDE  */
#line 660 "chuck.y"
                                            { (yyval.ival) = ae_op_divide; }
#line 3330 "chuck.tab.c"
    break;

  case 202: /* overloadable_operator: PERCENT  */
#line 661 "chuck.y"
                                            { (yyval.ival) = ae_op_percent; }
#line 3336 "chuck.tab.c"
    break;

  case 203: /* overloadable_operator: EQ  */
#line 662 "chuck.y"
                                            { (yyval.ival) = ae_op_eq; }
#line 3342 "chuck.tab.c"
    break;

  case 204: /* overloadable_operator: NEQ  */
#line 663 "chuck.y"
                                            { (yyval.ival) = ae_op_neq; }
#line 3348 "chuck.tab.c"
    break;

  case 205: /* overloadable_operator: LT  */
#line 664 "chuck.y"
                                            { (yyval.ival) = ae_op_lt; }
#line 3354 "chuck.tab.c"
    break;

  case 206: /* overloadable_operator: LE  */
#line 665 "chuck.y"
                                            { (yyval.ival) = ae_op_le; }
#line 3360 "chuck.tab.c"
    break;

  case 207: /* overloadable_operator: GT  */
#line 666 "chuck.y"
                                            { (yyval.ival) = ae_op_gt; }
#line 3366 "chuck.tab.c"
    break;

  case 208: /* overloadable_operator: GE  */
#line 667 "chuck.y"
                                            { (yyval.ival) = ae_op_ge; }
#line 3372 "chuck.tab.c"
    break;

  case 209: /* overloadable_operator: AND  */
#line 668 "chuck.y"
                                            { (yyval.ival) = ae_op_and; }
#line 3378 "chuck.tab.c"
    break;

  case 210: /* overloadable_operator: OR  */
#line 669 "chuck.y"
                                            { (yyval.ival) = ae_op_or; }
#line 3384 "chuck.tab.c"
    break;

  case 211: /* overloadable_operator: ASSIGN  */
#line 670 "chuck.y"
                                            { (yyval.ival) = ae_op_assign; }
#line 3390 "chuck.tab.c"
    break;

  case 212: /* overloadable_operator: EXCLAMATION  */
#line 671 "chuck.y"
                                            { (yyval.ival) = ae_op_exclamation; }
#line 3396 "chuck.tab.c"
    break;

  case 213: /* overloadable_operator: S_OR  */
#line 672 "chuck.y"
                                            { (yyval.ival) = ae_op_s_or; }
#line 3402 "chuck.tab.c"
    break;

  case 214: /* overloadable_operator: S_AND  */
#line 673 "chuck.y"
                                            { (yyval.ival) = ae_op_s_and; }
#line 3408 "chuck.tab.c"
    break;

  case 215: /* overloadable_operator: S_XOR  */
#line 674 "chuck.y"
                                            { (yyval.ival) = ae_op_s_xor; }
#line 3414 "chuck.tab.c"
    break;

  case 216: /* overloadable_operator: PLUSPLUS  */
#line 675 "chuck.y"
                                            { (yyval.ival) = ae_op_plusplus; }
#line 3420 "chuck.tab.c"
    break;

  case 217: /* overloadable_operator: MINUSMINUS  */
#line 676 "chuck.y"
                                            { (yyval.ival) = ae_op_minusminus; }
#line 3426 "chuck.tab.c"
    break;

  case 218: /* overloadable_operator: DOLLAR  */
#line 677 "chuck.y"
                                            { (yyval.ival) = ae_op_dollar; }
#line 3432 "chuck.tab.c"
    break;

  case 219: /* overloadable_operator: ATAT_SYM  */
#line 678 "chuck.y"
                                            { (yyval.ival) = ae_op_at_at; }
#line 3438 "chuck.tab.c"
    break;

  case 220: /* overloadable_operator: PLUS_CHUCK  */
#line 679 "chuck.y"
                                            { (yyval.ival) = ae_op_plus_chuck; }
#line 3444 "chuck.tab.c"
    break;

  case 221: /* overloadable_operator: MINUS_CHUCK  */
#line 680 "chuck.y"
                                            { (yyval.ival) = ae_op_minus_chuck; }
#line 3450 "chuck.tab.c"
    break;

  case 222: /* overloadable_operator: TIMES_CHUCK  */
#line 681 "chuck.y"
                                            { (yyval.ival) = ae_op_times_chuck; }
#line 3456 "chuck.tab.c"
    break;

  case 223: /* overloadable_operator: DIVIDE_CHUCK  */
#line 682 "chuck.y"
                                            { (yyval.ival) = ae_op_divide_chuck; }
#line 3462 "chuck.tab.c"
    break;

  case 224: /* overloadable_operator: S_AND_CHUCK  */
#line 683 "chuck.y"
                                            { (yyval.ival) = ae_op_s_and_chuck; }
#line 3468 "chuck.tab.c"
    break;

  case 225: /* overloadable_operator: S_OR_CHUCK  */
#line 684 "chuck.y"
                                            { (yyval.ival) = ae_op_s_or_chuck; }
#line 3474 "chuck.tab.c"
    break;

  case 226: /* overloadable_operator: S_XOR_CHUCK  */
#line 685 "chuck.y"
                                            { (yyval.ival) = ae_op_s_xor_chuck; }
#line 3480 "chuck.tab.c"
    break;

  case 227: /* overloadable_operator: SHIFT_RIGHT_CHUCK  */
#line 686 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_right_chuck; }
#line 3486 "chuck.tab.c"
    break;

  case 228: /* overloadable_operator: SHIFT_LEFT_CHUCK  */
#line 687 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_left_chuck; }
#line 3492 "chuck.tab.c"
    break;

  case 229: /* overloadable_operator: PERCENT_CHUCK  */
#line 688 "chuck.y"
                                            { (yyval.ival) = ae_op_percent_chuck; }
#line 3498 "chuck.tab.c"
    break;

  case 230: /* overloadable_operator: SHIFT_RIGHT  */
#line 689 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_right; }
#line 3504 "chuck.tab.c"
    break;

  case 231: /* overloadable_operator: SHIFT_LEFT  */
#line 690 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_left; }
#line 3510 "chuck.tab.c"
    break;

  case 232: /* overloadable_operator: TILDA  */
#line 691 "chuck.y"
                                            { (yyval.ival) = ae_op_tilda; }
#line 3516 "chuck.tab.c"
    break;

  case 233: /* overloadable_operator: COLONCOLON  */
#line 692 "chuck.y"
                                            { (yyval.ival) = ae_op_coloncolon; }
#line 3522 "chuck.tab.c"
    break;

  case 234: /* overloadable_operator: AT_CHUCK  */
#line 693 "chuck.y"
                                            { (yyval.ival) = ae_op_at_chuck; }
#line 3528 "chuck.tab.c"
    break;

  case 235: /* overloadable_operator: UNCHUCK  */
#line 694 "chuck.y"
                                            { (yyval.ival) = ae_op_unchuck; }
#line 3534 "chuck.tab.c"
    break;

  case 236: /* overloadable_operator: UPCHUCK  */
#line 695 "chuck.y"
                                            { (yyval.ival) = ae_op_upchuck; }
#line 3540 "chuck.tab.c"
    break;

  case 237: /* overloadable_operator: DOWNCHUCK  */
#line 696 "chuck.y"
                                            { (yyval.ival) = ae_op_downchuck; }
#line 3546 "chuck.tab.c"
    break;

  case 238: /* overloadable_operator: ARROW_RIGHT  */
#line 697 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_right; }
#line 3552 "chuck.tab.c"
    break;

  case 239: /* overloadable_operator: ARROW_LEFT  */
#line 698 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_left; }
#line 3558 "chuck.tab.c"
    break;

  case 240: /* overloadable_operator: GRUCK_RIGHT  */
#line 699 "chuck.y"
                                            { (yyval.ival) = ae_op_gruck_right; }
#line 3564 "chuck.tab.c"
    break;

  case 241: /* overloadable_operator: GRUCK_LEFT  */
#line 700 "chuck.y"
                                            { (yyval.ival) = ae_op_gruck_left; }
#line 3570 "chuck.tab.c"
    break;

  case 242: /* overloadable_operator: UNGRUCK_RIGHT  */
#line 701 "chuck.y"
                                            { (yyval.ival) = ae_op_ungruck_right; }
#line 3576 "chuck.tab.c"
    break;

  case 243: /* overloadable_operator: UNGRUCK_LEFT  */
#line 702 "chuck.y"
                                            { (yyval.ival) = ae_op_ungruck_left; }
#line 3582 "chuck.tab.c"
    break;

  case 245: /* dur_expression: dur_expression COLONCOLON postfix_expression  */
#line 708 "chuck.y"
            { (yyval.exp) = new_exp_from_dur( (yyvsp[-2].exp), (yyvsp[0].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3588 "chuck.tab.c"
    break;

  case 246: /* postfix_expression: primary_expression  */
#line 712 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3594 "chuck.tab.c"
    break;

  case 247: /* postfix_expression: postfix_expression array_exp  */
#line 714 "chuck.y"
            { (yyval.exp) = new_exp_from_array( (yyvsp[-1].exp), (yyvsp[0].array_sub), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3600 "chuck.tab.c"
    break;

  case 248: /* postfix_expression: postfix_expression LPAREN RPAREN  */
#line 716 "chuck.y"
            { (yyval.exp) = new_exp_from_func_call( (yyvsp[-2].exp), NULL, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3606 "chuck.tab.c"
    break;

  case 249: /* postfix_expression: postfix_expression LPAREN expression RPAREN  */
#line 718 "chuck.y"
            { (yyval.exp) = new_exp_from_func_call( (yyvsp[-3].exp), (yyvsp[-1].exp), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 3612 "chuck.tab.c"
    break;

  case 250: /* postfix_expression: postfix_expression DOT ID  */
#line 720 "chuck.y"
            { (yyval.exp) = new_exp_from_member_dot( (yyvsp[-2].exp), (yyvsp[0].sval), (yylsp[-2]).first_line, (yylsp[-2]).first_column, (yylsp[0]).first_column ); }
#line 3618 "chuck.tab.c"
    break;

  case 251: /* postfix_expression: postfix_expression PLUSPLUS  */
#line 722 "chuck.y"
            { (yyval.exp) = new_exp_from_postfix( (yyvsp[-1].exp), ae_op_plusplus, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3624 "chuck.tab.c"
    break;

  case 252: /* postfix_expression: postfix_expression MINUSMINUS  */
#line 724 "chuck.y"
            { (yyval.exp) = new_exp_from_postfix( (yyvsp[-1].exp), ae_op_minusminus, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3630 "chuck.tab.c"
    break;

  case 253: /* primary_expression: ID  */
#line 729 "chuck.y"
                                            { (yyval.exp) = new_exp_from_id( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3636 "chuck.tab.c"
    break;

  case 254: /* primary_expression: INT_VAL  */
#line 730 "chuck.y"
                                            { (yyval.exp) = new_exp_from_int( (yyvsp[0].ival), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3642 "chuck.tab.c"
    break;

  case 255: /* primary_expression: FLOAT_VAL  */
#line 731 "chuck.y"
                                            { (yyval.exp) = new_exp_from_float( (yyvsp[0].fval), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3648 "chuck.tab.c"
    break;

  case 256: /* primary_expression: STRING_LIT  */
#line 732 "chuck.y"
                                            { (yyval.exp) = new_exp_from_str( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3654 "chuck.tab.c"
    break;

  case 257: /* primary_expression: CHAR_LIT  */
#line 733 "chuck.y"
                                            { (yyval.exp) = new_exp_from_char( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3660 "chuck.tab.c"
    break;

  case 258: /* primary_expression: array_exp  */
#line 734 "chuck.y"
                                            { (yyval.exp) = new_exp_from_array_lit( (yyvsp[0].array_sub), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3666 "chuck.tab.c"
    break;

  case 259: /* primary_expression: complex_exp  */
#line 735 "chuck.y"
                                            { (yyval.exp) = new_exp_from_complex( (yyvsp[0].complex_exp), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3672 "chuck.tab.c"
    break;

  case 260: /* primary_expression: polar_exp  */
#line 736 "chuck.y"
                                            { (yyval.exp) = new_exp_from_polar( (yyvsp[0].polar_exp), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3678 "chuck.tab.c"
    break;

  case 261: /* primary_expression: vec_exp  */
#line 737 "chuck.y"
                                            { (yyval.exp) = new_exp_from_vec( (yyvsp[0].vec_exp), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3684 "chuck.tab.c"
    break;

  case 262: /* primary_expression: L_HACK expression R_HACK  */
#line 738 "chuck.y"
                                            { (yyval.exp) = new_exp_from_hack( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3690 "chuck.tab.c"
    break;

  case 263: /* primary_expression: LPAREN expression RPAREN  */
#line 739 "chuck.y"
                                            { (yyval.exp) = (yyvsp[-1].exp); }
#line 3696 "chuck.tab.c"
    break;

  case 264: /* primary_expression: LPAREN RPAREN  */
#line 740 "chuck.y"
                                                    { (yyval.exp) = new_exp_from_nil( (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3702 "chuck.tab.c"
    break;


#line 3706 "chuck.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

